/*
 * Created on Oct 12, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.agency;

import it.polito.elite.doseWS.agency.behaviours.ListenMessageBehaviour;
import it.polito.elite.doseWS.agency.parsers.MsgParser;
import it.polito.elite.doseWS.agency.messages.*;

import it.polito.elite.doseWS.include.Synset;
import it.polito.elite.doseWS.include.MWord;

import it.polito.elite.doseWS.wrappers.DBWrapperImpl;


import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Set;
import java.util.Iterator;

import java.io.File;
import java.io.FileWriter;

/*
import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.encoding.ser.JAFDataHandlerDeserializerFactory;
import org.apache.axis.encoding.ser.JAFDataHandlerSerializerFactory;
*/
import jade.lang.acl.*;
import jade.core.AID;

/**
 * @author bonino
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SynsetManager extends DOSEAgent {

	//define the service identifier
	public static final String SERVICE = "SynsetDelivery";
	public static final String filePrefix = "synset_";

	//----DBWrapper parameters----
	private String dbUser = null;

	private String dbPassword = null;

	private String dbUri = null;

	private String dbDriver = null;

	//----------------------------

	//----Onto parameters----
	private String ontoUri = null;

	//-----------------------

	//----Message handling---
	private MsgParser msgParser = null;

	//-----------------------

	//----Status parameter----
	private boolean isAlive = false;

	//------------------------

	//----Storage instance----
	private DBWrapperImpl storage = null;

	//Agency manager address
	private AID manager;

	//dummy constructor for testing purpose
	public SynsetManager()
	{

	}

	public void setup() {
		//extracting initialization parameters
		Object args[] = this.getArguments();

		//DBWrapper parameters
		this.dbDriver = (String)args[0];
		this.dbUser = (String) args[1];
		this.dbPassword = (String) args[2];
		this.dbUri = (String) args[3];

		//instancing the storage
		try {
			this.storage = new DBWrapperImpl(this.dbDriver,this.dbUri,this.dbUser,this.dbPassword);
		} catch (Exception e) {
			System.err.println("Error while creating DBWrapperImpl: " + e);
			this.doDelete();
		}

		//ontology parameters
		this.ontoUri = (String) args[4];
	this.manager = (AID) args[5];

		//the message parser
		this.msgParser = new MsgParser();

		//registering allowed messages
		this.msgParser.register(LearningMessage.class);
		this.msgParser.register(IsAlive.class);
		this.msgParser.register(SynsetRequestMessage.class);
		this.msgParser.register(Die.class);

		//adding the listening Behaviour
		this.addBehaviour(new ListenMessageBehaviour(this));

		//changing state to Alive
		this.isAlive = true;

		this.sendRemoteLog("I'm Alive",this.manager);

		//register agent to the Directory Facilitator
		this.register(SynsetManager.SERVICE);
	}

	public void handleMessage(ACLMessage msg) {
		//extracting the message content
		String msgContent = msg.getContent();

		//preparing the reply message
		ACLMessage reply = msg.createReply();

		//getting the proto-message from parser
		Message decodedMessage = this.msgParser.routeMessage(msgContent);

		//selecting actions
		if (decodedMessage instanceof IsAlive)
			this.manageIsAlive(reply);
		if (decodedMessage instanceof LearningMessage)
			this.manageLearningMessage(reply, (LearningMessage)decodedMessage);
		if (decodedMessage instanceof SynsetRequestMessage){
		  this.sendRemoteLog("Synrequest!!!",manager);
		  this.manageSynsetRequestMessage(reply,
						  (SynsetRequestMessage) decodedMessage);
		}
		if (decodedMessage instanceof Die)
			this.manageDie();
	}

	private void manageIsAlive(ACLMessage toSend) {
		//creating return message
		ImAlive alive = new ImAlive(SynsetManager.SERVICE);

		//building the reply message
		if (this.isAlive)
			toSend.setContent(alive.createMsg());

		//sending alive message
		this.send(toSend);
	}
	private void manageDie()
	{
		this.doDelete();
	}

	private void manageLearningMessage(ACLMessage toSend, LearningMessage toLearn) {
		//managing learning messages
		this.manageUpdates(toLearn);
	}

	private void manageSynsetRequestMessage(ACLMessage toSend,
			SynsetRequestMessage request) {

		//sending Response
		//(this.sendSynsetRequestResponse(request);

		//remote logging
		String responseContent = this.buildSynsetFileContent(request);
		//System.out.println("SynsetManager Sending content: "+responseContent);

		//creating acknowledge message
		SynsetResponseMessage ack = new SynsetResponseMessage(responseContent);

		//remote logging
		//System.out.println("SynsetManager Sending content: "+ack.getContent());

		//building the reply message
		toSend.setContent(ack.createMsg());

		//remote logging
		//System.out.println("SynsetManager Sending: "+toSend.getContent());

		//sending ack message
		this.send(toSend);
	}

	private void manageUpdates(LearningMessage msg)
	{
		
		//debug 
		this.sendRemoteLog(">>>>> Received Learning Message <<<<<",this.manager);
		//extract the concepts for which synsets should
		//be updated
		Set conceptsToUpdate = msg.getConceptsToUpdate();

		//gets to update iterator
		Iterator iterUpdate = conceptsToUpdate.iterator();

		//for each concept updates the synset db
		while(iterUpdate.hasNext())
		{
			//get the concept
			String concept = (String)iterUpdate.next();
			//for each concept extract the synset
			Synset syn = msg.getToUpdateSynset(concept);
			
			//debug
			this.sendRemoteLog(syn.serialize(),this.manager);
			
			//update the db
			try
			{
				this.storage.updateSynset(syn,true);
			}
			catch(Exception e)
			{
				//debug
				System.out.println("Error on synset update: "+e);
			}
		}
	}

	private String buildSynsetFileContent(SynsetRequestMessage request)
	{
		//the synset vector
		Synset allSyns[] = null;
		int total = 1;
		try
		{
			//insert here the access to data storage
			allSyns = this.storage.getAnySynset(request.lang());
			//get the total number of annotations
			total = this.storage.countAnnotations();
		}
		catch(Exception e)
		{
			//debug
			System.out.println("Error when accessing DB for getting synsets: "+e);
			return "";
		}

		//test
		//allSyns[0]= new Synset("prova",new MWord []{new MWord("prova",1,1.0),new MWord("prova",1,2.0)},"IT");

		//building the message
		StringBuffer msgContent = new StringBuffer();

		//appending start tag
		msgContent.append(this.makePreamble());

		//creating content
		for (int i = 0; i < allSyns.length; i++) {
			//evaluate annotation probability
			double annoProbability = this.evaluateAnnoProbability(allSyns[i]
					.getConcept(), total);

			//build the synset tag
			msgContent.append("<SYNSET concept=\"" + allSyns[i].getConcept()
					+ "\" annoProbability=\"" + annoProbability + "\">");

			//send remote log
			this.sendRemoteLog("Annotation Probability: "+annoProbability,this.manager);

			//evaluate probability
			this.evaluateProbability(allSyns[i]);
			msgContent.append(allSyns[i].serialize());

			//close the synset tag
			msgContent.append("</SYNSET>");
		}

		//appending the end tag
		msgContent.append(this.makeClosure());

		return msgContent.toString();
	}

	private File buildTempFile(SynsetRequestMessage request) {
		File tempFile = null;
		try {
			//build the temporary file
			tempFile = File.createTempFile("SynResp", null);

			//creating the writer
			FileWriter writer = new FileWriter(tempFile);

			//writing the file
			writer.write(this.buildSynsetFileContent(request));

			//flushing data
			writer.flush();

			//closing writer
			writer.close();

		} catch (Exception e) {
			System.out.println("Error while writing temporary file: " + e);
		}
		return tempFile;
	}

	private String makePreamble() {
		String preamble = new String();

		//getting the current time as a calendar object
		Calendar now = Calendar.getInstance();

		//updating the date with the forseen expiration
		//date
		now.add(Calendar.SECOND, 10);

		//preparing date formatter
		SimpleDateFormat df = (SimpleDateFormat)DateFormat.getDateTimeInstance();
		df.applyPattern("yyyy:MM:dd:hh:mm:ss:S:Z");
		//creating the message preamble
		preamble = "<SYNSETS onto=\"" + this.ontoUri + "\" expiration=\""
				+ df.format(now.getTime()) + "\">";

		//returning the preamble
		return preamble;
	}

	private String makeClosure() {
		return new String("</SYNSETS>");
	}
/*
	private boolean sendSynsetRequestResponse(SynsetRequestMessage request)
	{
		//build the return value
		Boolean ret = new Boolean(false);

		//build the response file
		File response = this.buildTempFile(request);

		try {
			//defining the data handler for transfering the temp file
			DataHandler dh = new DataHandler(new FileDataSource(response));

			//creating a new Service object
			Service service = new Service();

			//create a new call object
			Call call = (Call) service.createCall();

			//extracting endpoints from request
			String endpoint = request.getEndpoint();

			//setting endpoints for sending the file
			call.setTargetEndpointAddress(new java.net.URL(endpoint));

			//setting the operation name
			call.setOperationName(new QName("urn:ContainerProviderWS", "uploadFile"));

			//setting the attachment name
			QName qnameAttachment = new QName("urn:ContainerProviderWS",
			"DataHandler");

			//registering the attachment
			call.registerTypeMapping(dh.getClass(), //Add serializer for
					// attachment.
					qnameAttachment,
					JAFDataHandlerSerializerFactory.class,
					JAFDataHandlerDeserializerFactory.class);

			//registering parameter types
			call.addParameter("dh",qnameAttachment, ParameterMode.IN);
			call.addParameter("name",XMLType.XSD_STRING, ParameterMode.IN);

			//building parameters
			Object params[] = new Object[2];
			params[0] = dh;
			params[1] = SynsetManager.filePrefix+request.lang()+".xml";

			//sending the file
			ret = (Boolean) call.invoke(params);

		}
		catch (Exception ex) {
			return false;
		}

		//deleting temp file
		response.delete();

		return ret.booleanValue();
	}
*/
private void evaluateProbability(Synset s) {
		//extract the synset mwords
		MWord mwords[] = s.getMWords();

		//the overall weighted occurrence container
		double wOccurrence = 0.0;
		//compute the overall weighted occurrence
		for (int i = 0; i < mwords.length; i++) {
			wOccurrence += (mwords[i].getFrequency() * mwords[i].getWeight());
		}
		//compute the probability for each mword in the synset
		//and stores the value in the corresponding mword object
		if (wOccurrence != 0)
			for (int j = 0; j < mwords.length; j++)
				mwords[j].setProbability((mwords[j].getFrequency() * mwords[j]
						.getWeight())
						/ wOccurrence);

		//store the mwords in the synset
		s.setMWords(mwords);
	}

	private double evaluateAnnoProbability(String uri, int totalAnnotations) {

		int nAnnotations = 0;
		if(totalAnnotations <1) return 0.0;
		//get the number of Annotations about the concept
		try
		{
			nAnnotations = this.storage.countAnnotations(uri);
		}
		catch(Exception e)
		{
			//debug
			System.out.println("Error when accessing DB for getting synsets: "+e);
			return 0.0;
		}
		//returns the probability value
		return (double)nAnnotations / (double)totalAnnotations;
	}
}