package it.polito.elite.doseWS.agency.behaviours;

import jade.core.behaviours.*;
import it.polito.elite.doseWS.agency.FilterAgent;
import java.util.Iterator;
/**
 *
 * <p>Title: CheckFilteringRequests </p>
 * <p>Description: This behaviour periodically checks the request queue and performs
 * a filtering operation in the event. The actual filtering is done by the filter
 * method of the AgencyManager.</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Politecnico di Torino</p>
 * @author alessio.bosca@polito.it
 */
public class CheckFilteringRequests extends CyclicBehaviour
{
  FilterAgent myAgent;

  public CheckFilteringRequests(FilterAgent agent)
  {
    this.myAgent=agent;
  }

  public void action()
  {
    if (myAgent.requests.size()>0) {
      Iterator it=myAgent.requests.iterator();
      String url=(String) it.next();
      it.remove();
      //The actual filtering
      this.myAgent.filter(url);
    }
    else {
      block(10000);
    }

  }

}