package it.polito.elite.doseWS.agency.behaviours;

import jade.core.behaviours.*;
import jade.lang.acl.*;
import it.polito.elite.doseWS.agency.*;

/**
 * <p>Title: ListenMessageBehaviour </p>
 * <p>Description: Behaviour for message handling in DOSE environment. Each DoseAgent
 * must implement an handleMessage method in order to manage the received ACLMessages.</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Politecnico di Torino</p>
 * @author alessio.bosca@polito.it
 */
public class ListenMessageBehaviour extends CyclicBehaviour
{
  DOSEAgent myAgent;

  /**
   * Constructs the Bheaviour
   * @param myAgent A reference to an agent extending DOSEAgent
   */
  public ListenMessageBehaviour(DOSEAgent myAgent)
  {
    super(myAgent);
    this.myAgent = myAgent;
  }

  public void action()
  {
    ACLMessage msg = myAgent.receive();
    if (msg != null) {
      //The actual handling
      myAgent.handleMessage(msg);

    }
    else {
      block(9000);
    }

  }

}