package it.polito.elite.doseWS.agency.behaviours;

import jade.core.behaviours.*;
import java.util.HashSet;
import it.polito.elite.doseWS.agency.DOSEAgent;

/**
 *
 * <p>Title: ScheduleNextProvidersRefresh </p>
 * <p>Description: It schedules a new GetAgentProviders behaviour after a certain
 * amount of time, specified in the constructor</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Politecnico di Torino</p>
 * @author alessio.bosca@polito.it
 */
public class ScheduleNextProvidersRefresh extends WakerBehaviour
{
  DOSEAgent myAgent;
  String serviceDescription;
  HashSet results;
  long period;

  /**
   * Base Constructor
   * @param agent The DOSEAgent scheduling this behaviour
   * @param period Amount of millisec between two checking phases
   * @param serviceDescription The description of the service exported by the searched agents
   * @param results The collections where the AIDs are stored
   */
  public ScheduleNextProvidersRefresh(DOSEAgent agent, long period,
                                      String serviceDescription,
                                      HashSet results)
  {
    super(agent, period);
    this.results = results;
    this.serviceDescription = serviceDescription;
    this.myAgent = agent;
    this.period = period;
  }

  protected void handleElapsedTimeout()
  {
    //Schedules a GetAgentProviders behaviour in order to refresh the list of id
    this.myAgent.addBehaviour(new GetAgentProviders(this.myAgent,
        this.period, this.serviceDescription, this.results));
  }

}
