package it.polito.elite.doseWS.agency.messages;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
import org.xml.sax.*;

/**
 *
 * <p>Title: AnnotationPreRequestMessage </p>
 * <p>Description: Annotation PreReques, specifing the language of
 * the document. Sent by a FilterAgent in order to obtain the address of the better
 * Annotator possible within the agency, for freshness of synset and less workload.</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Politecnico di Torino</p>
 * @author alessio.bosca@polito.it
 */
public class AnnotationPreRequestMessage extends Message
{
  final static String ID = "AnnoPreReq";
  String language;

  public AnnotationPreRequestMessage(String lang)
  {
    this.language = lang;
  }

  public String createMsg()
  {
    return new StringBuffer().append("<MSG id=\"" +
                                     AnnotationPreRequestMessage.ID + "\">").
        append("<LANG>").append(this.language).append("</LANG>").append("</MSG>").
        toString();
  }

  public static String getID()
  {
    return AnnotationPreRequestMessage.ID;
  }

  public static Message parse(String msg)
  {
    AnnotationPreRequestMessage resp;
    try {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = factory.newDocumentBuilder();
      //Reader for the msg
      StringReader reader = new StringReader(msg);
      //InputSource for the msg
      InputSource source = new InputSource(reader);
      // parses the xml
      Document doc = builder.parse(source);
      Element elemRoot = doc.getDocumentElement();
      //Get language
      Element lang = (Element) elemRoot.getElementsByTagName("LANG").item(0);
      String langStr = ( (org.w3c.dom.Text) lang.getFirstChild()).getData();
      resp = new AnnotationPreRequestMessage(langStr);
    }
    catch (Exception ex) {
      System.out.println(ex);
      return null;
    }
    return resp;
  }

  public String getLanguage()
  {
    return language;
  }

}