package it.polito.elite.doseWS.agency.messages;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
import org.xml.sax.*;
import it.polito.elite.doseWS.agency.messages.Message;

/**
 *
 * <p>Title: ImAlive </p>
 * <p>Description: The default response to an IsAlive message. It specify the service
 * exported by the agent.</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Politecnico di Torino</p>
 * @author alessio.bosca@polito.it
 */
public class ImAlive extends Message
{
  static final String ID="ImAlive";
  private String service;

  public ImAlive(String service){
    this.service=service;
  }
   public String createMsg()
   {
     return new StringBuffer("<MSG id=\""+ImAlive.ID+"\">").append("<SERVICE>").append(this.service).append("</SERVICE>").append(
        "</MSG>").toString();
   }

   public static String getID()
   {
     return ImAlive.ID;
   }

   public String getService()
   {
     return this.service;
   }

   public static Message parse(String msg)
   {
     ImAlive resp;
    try {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = factory.newDocumentBuilder();
      //Reader for the msg
      StringReader reader = new StringReader(msg);
      //InputSource for the msg
      InputSource source = new InputSource(reader);
      // parses the xml
      Document doc = builder.parse(source);
      Element elemRoot = doc.getDocumentElement();
      // get the description of the service as a string
      Element elm = (Element) elemRoot.getElementsByTagName("SERVICE").item(0);
      String service = ( (org.w3c.dom.Text) elm.getFirstChild()).getData();
      resp=new ImAlive(service);
    }
    catch (Exception ex) {
      System.out.println(ex);
      return null;
    }
    return resp;
   }
}