package it.polito.elite.doseWS.agency.messages;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
import org.xml.sax.*;

/**
 *
 * <p>Title: IndexReportMessage </p>
 * <p>Description: Informs that an URI has been succesfully indexed</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Politecnico di Torino</p>
 * @author alessio.bosca@polito.it
 */
public class IndexReportMessage extends Message
{
  final static String ID = "IndexReport";
  String url;

  public IndexReportMessage(String url)
  {
    this.url=url;
  }


  public String createMsg()
  {
    //The URI is in CDATA format in order to get rid of ? and & stuff
    return new StringBuffer("<MSG id=\"" + IndexReportMessage.ID + "\">").
        append("<URL>").append("<![CDATA["+this.url+"]]>").append("</URL>").append("</MSG>").
        toString();
  }

  public static String getID()
  {
    return IndexReportMessage.ID;
  }

  public static Message parse(String msg)
  {
    IndexReportMessage resp;
    try {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = factory.newDocumentBuilder();
      //Reader for the msg
      StringReader reader = new StringReader(msg);
      //InputSource for the msg
      InputSource source = new InputSource(reader);
      // parses the xml
      Document doc = builder.parse(source);
      Element elemRoot = doc.getDocumentElement();
      //get the URL
      Element url = (Element) elemRoot.getElementsByTagName("URL").item(0);
      String urlStr = ( (org.w3c.dom.Text) url.getFirstChild()).getData();
      resp=new IndexReportMessage(urlStr);
    }
    catch (Exception ex) {
      System.out.println(ex);
      return null;
    }
    return resp;
  }

  public String getCompletedURL()
  {
    return url;
  }

}