/*
 * Created on Oct 11, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.agency.messages;

import junit.framework.TestCase;
import java.util.Set;
import java.util.Iterator;
import it.polito.elite.doseWS.include.Synset;
import it.polito.elite.doseWS.include.MWord;

/**
 * @author bonino
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class LearningMessageTest extends TestCase {

	//the test message
	String msg;
	public static void main(String[] args) {
		junit.swingui.TestRunner.run(LearningMessageTest.class);
	}

	/**
	 * Constructor for LearningMessageTest.
	 * @param arg0
	 */
	public LearningMessageTest(String arg0) {
		super(arg0);
		
		//initializing the test message
		this.msg = "<MSG id=\"learning\" lang=\"it\"><CONCEPT uri=\"http://uriexample.com\">"+
		"<MWORD occurrence=\"12\">mword1</MWORD><MWORD occurrence=\"3\">mword2</MWORD>"+
		"</CONCEPT><CWORD occurrence=\"3\">cword2</CWORD></MSG>";
	}
	
	public void testParse()
	{
		// the concepts for comparison  
		String concepts[]= new String[]{"http://uriexample.com"};
		
		//parse the test message
		LearningMessage learn = (LearningMessage)LearningMessage.parse(msg);
		
		//extract the set of concepts to Update
		Set conceptSet = learn.getConceptsToUpdate();
		
		//gets an iterator over such concepts
		Iterator iter = conceptSet.iterator();
		
		//initialize the cursor for the concepts array
		int i=0;
		
		//for each concept to update
		while(iter.hasNext())
		{
			//test if the retrieved concept is equal to the one
			//stored in the correspondent position of the array
			//concepts
			assertEquals(concepts[i],(String)iter.next());
			
			//update the cursor
			i++;
		}
	}
	
	public void testGetToLearnMWords()
	{
		//parse the test message
		LearningMessage learn = (LearningMessage)LearningMessage.parse(msg);
		
		//get the synset corresponding to the given concept uri
		Set syn = learn.getToLearnMWords();
		
		//gets the iterator
		Iterator iter = syn.iterator();
		
		//prints out the words to learn
		while (iter.hasNext())
		{
			MWord mword = (MWord)iter.next();
			assertEquals("cword2",mword.getMWord());
		}
	}

	public void testGetToUpdateSynset()
	{
		//parse the test message
		LearningMessage learn = (LearningMessage)LearningMessage.parse(msg);
		
		//get the synset corresponding to the given concept uri
		Synset syn = learn.getToUpdateSynset("http://uriexample.com");
		
		//test the language
		assertEquals("it",syn.getLanguage());
		
		//tests if the concept uri stored in the synset is equal
		//to the given one
		assertEquals("http://uriexample.com",syn.getConcept());
		
		//get the set of mwords stored in the synset
		MWord mwords[] = syn.getMWords();
		
		//test if the retrieved mwords are equal to their expected values
		assertEquals("mword1",mwords[0].getMWord());
		assertEquals("mword2",mwords[1].getMWord());
		assertEquals(12,mwords[0].getFrequency());
		assertEquals(3,mwords[1].getFrequency());
	}
	
	public void testConceptsToUpdate()
	{
		//the concepts for comparison 
		String concepts[]= new String[]{"http://uriexample.com"};
		
		//parse the test message
		LearningMessage learn = (LearningMessage)LearningMessage.parse(msg);
		
		//extract the set of concepts to Update
		Set conceptSet = learn.getConceptsToUpdate();
		
		//gets an iterator over such concepts
		Iterator iter = conceptSet.iterator();
		
		//initialize the cursor for the concepts array
		int i=0;
		
		//for each concept to update
		while(iter.hasNext())
		{
			//test if the retrieved concept is equal to the one
			//stored in the correspondent position of the array
			//concepts
			assertEquals(concepts[i],(String)iter.next());
			
			//update the cursor
			i++;
		}
	}
	public void testConceptsToLearn()
	{
		//the concepts for comparison 
		String concepts[]= new String[]{"http://uriexample.com"};
		
		//parse the test message
		LearningMessage learn = (LearningMessage)LearningMessage.parse(msg);
		
		//extract the set of concepts to Learn
		Set conceptSet = learn.getConceptsToLearn();
		
		//gets an iterator over such concepts
		Iterator iter = conceptSet.iterator();
		
		//initialize the cursor for the concepts array
		int i=0;
		
		//for each concept to update
		while(iter.hasNext())
		{
			//test if the retrieved concept is equal to the one
			//stored in the correspondent position of the array
			//concepts
			assertEquals(concepts[i],(String)iter.next());
			
			//update the cursor
			i++;
		}
	}
	
	public void testGetID()
	{
		assertEquals("learning",LearningMessage.getID());
	}
	
	public void testCreateAckMsg()
	{
		LearningMessage ack = new LearningMessage();
		String ackMsg = ack.createAckMsg();
		//System.out.println("Acknowledge message: "+ackMsg);
		assertEquals("<MESSAGE id=\"acknowledgeLearning\" />",ackMsg);
	}
}
