/*
 * Created on Oct 12, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.agency.parsers;
import java.io.StringReader;
import java.util.HashSet;
import java.util.Iterator;
import java.lang.reflect.Method;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;

import it.polito.elite.doseWS.agency.messages.*;

/**
 * @author bonino
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MsgParser {

	private HashSet messageSet;

	public MsgParser()
	{
		//instantiates the message register
		this.messageSet = new HashSet();
	}

	public void register(Class messageHandler)
	{
		//register a class for message handling
		this.messageSet.add(messageHandler);
	}

	public void deRegister(Class messageHandler)
	{
		//de-register a class for message handling
		if(this.messageSet.contains(messageHandler))
			this.messageSet.remove(messageHandler);
	}

	public Message routeMessage(String msg)
	{
		/*
		 * parses the first row of the message and istantiates
		 * the correct message object
		 */

		Message message= null;

		String id = this.parseID(msg);

		//gets an iterator over registered message handler
		Iterator iter = this.messageSet.iterator();

		//route message on the correct object
		while(iter.hasNext())
		{
			Class handler = (Class)iter.next();

			//debug
			//System.out.println("Handler Class: "+handler.getName());
			try
			{
				Method getID = handler.getDeclaredMethod("getID",new Class[]{});
				//System.out.println("Method:"+getID);
				String messageID = (String)getID.invoke(handler,null);

				//debug
				//System.out.println("message id: "+messageID);
				if(messageID.equalsIgnoreCase(id))
				{
					//accesses the parse method for the handler class
					Method parse = handler.getDeclaredMethod("parse",new Class[]{String.class});

					//invokes the method parse
					message = (Message)parse.invoke(handler,new Object[]{msg});

					//debug
					//System.out.println("Message: "+message.toString());
				}
			}
			catch(Exception e)
			{
				System.out.println("Exception:"+e);
				return new NotUnderstood();
			}

		}
		return message;
	}

	private String parseID(String msg)
	{
		String id = null;
		try
		{
			//getting the document builder Factory
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

			// getting the document builder from the Factory
			DocumentBuilder builder = factory.newDocumentBuilder();

			//Reader for the msg
			StringReader reader = new StringReader(msg);

			//InputSource for the msg
			InputSource source = new InputSource(reader);

			// parses the xml
			Document synDoc = builder.parse(source);

			// extract the element root of the message
			Element root = synDoc.getDocumentElement();

			//extract the message id
			id = root.getAttribute("id");
		}
		catch(Exception e)
		{
			return null;
		}
		return id;
	}

}
