/*
 * Created on Sep 25, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.include;

import java.io.Serializable;
import java.util.Comparator;

/**
 * A class for doing comparisons between conceptual spectra, since the spectra do not possess a
 * self-ordering relation, they should be ordered with respect to a given reference spectra.
 * 
 * @author <a href="mailto:dario.bonino@polito.it">Dario Bonino</a>
 * <a href="mailto:alessio.bosca@polito.it">Alessio Bosca</a>
 * <a href="mailto:federico.pescarmona@polito.it">Federico Pescarmona</a>
 * <a href="mailto:michele.debandi@polito.it">Michele Debandi</a>
 *
 *@see the SpectraRankComparatorTest for a test class
 *@version 1.0
 *@since 11/2004
 */
public class SpectraRankComparator implements Comparator, Serializable {

	/* (non-Javadoc)
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	private Spectrum base;
	/**
	 * 
	 * @param base the reference spectra for doing comparisons
	 */
	public SpectraRankComparator(Spectrum base)
	{
		this.base = base;
	}
	/**
	 * The comparator method
	 * @param o1 the first object to be compared
	 * @param o2 the second object to be compared
	 */
	public int compare(Object o1, Object o2) 
	{
		//evaluation of the distance with respect to the base
		double dist1 = base.dist(base,(Spectrum)o1);
		double dist2 = base.dist(base,(Spectrum)o2);
		if(dist1 > dist2) return -1;
		if(dist1 < dist2) return 1;
		return 0;
	}

}
