/*
 * SpectrumImplTest.java
 * JUnit based test
 *
 * Created on July 6, 2004, 2:51 PM
 */

package it.polito.elite.doseWS.include;

import java.util.Hashtable;
import java.lang.Double;
import junit.framework.*;

/**
 *The JUnit test for the SpectrumImpl class
 *
 * @author <a href="mailto:dario.bonino@polito.it">Dario Bonino</a>
 * <a href="mailto:alessio.bosca@polito.it">Alessio Bosca</a>
 * <a href="mailto:federico.pescarmona@polito.it">Federico Pescarmona</a>
 * <a href="mailto:michele.debandi@polito.it">Michele Debandi</a>
 *
 * @version 1.0
 * @since 11/2004
 */
public class SpectrumImplTest extends TestCase
{
	Spectrum testSpectrum1,testSpectrum2;
	
	public SpectrumImplTest(java.lang.String testName)
	{
		super(testName);
		Hashtable testVector1 = new Hashtable();
		Hashtable testVector2 = new Hashtable();
		
		for (int i=0; i<20; i++)
		{
			double weight1 = Math.random();
			double weight2 = Math.random();
			testVector1.put("topic"+i,new Double(weight1));
			testVector2.put("topic"+i,new Double(weight2));
		}
		testSpectrum1 = new SpectrumImpl("uri1","Xpath1","Dario","junit",testVector1);
		testSpectrum2 = new SpectrumImpl("uri2","Xpath2","Dario","junit",testVector2);
	}
	
	public static Test suite()
	{
		TestSuite suite = new TestSuite(SpectrumImplTest.class);
		return suite;
	}
	
	/**
	 * Test of getFragmentURI method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testGetFragmentURI()
	{
		System.out.println("testGetFragmentURI");
		
		// TODO add your test code below by replacing the default call to fail.
		System.out.println("Fragment URI:"+this.testSpectrum1.getFragmentURI());
	}
	
	/**
	 * Test of getFragmentXPath method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testGetFragmentXPath()
	{
		System.out.println("testGetFragmentXPath");
		
		System.out.println("Fragment XPath:"+this.testSpectrum1.getFragmentXPath());
	}
	
	/**
	 * Test of getAuthor method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testGetAuthor()
	{
		System.out.println("testGetAuthor");
		
		System.out.println("Annotations author:"+this.testSpectrum1.getAuthor());
	}
	
	/**
	 * Test of getType method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testGetType()
	{
		System.out.println("testGetType");
		
		System.out.println("Annotations type:"+this.testSpectrum1.getType());
	}
	
	/**
	 * Test of getConcepts method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testGetConcepts()
	{
		System.out.println("testGetConcepts");
		
		System.out.println("concepts and weights:"+this.testSpectrum1.getConcepts().toString());
	}
	
	/**
	 * Test of dist method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testDist()
	{
		System.out.println("testDist");
		
		System.out.println("Distance between spectra:"+this.testSpectrum1.dist(testSpectrum1,testSpectrum2));
	}
	
	/**
	 * Test of setDistParameters method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testSetDistParameters()
	{
		System.out.println("testSetDistParameters");
		
		// TODO add your test code below by replacing the default call to fail.
		//fail("The test case is empty.");
	}
	
	/**
	 * Test of clone method, of class it.polito.elite.doseWS.include.SpectrumImpl.
	 */
	public void testClone()
	{
		System.out.println("testClone");
		try
		{
		Spectrum clone = (Spectrum)this.testSpectrum1.clone();
		System.out.println("clone:"+clone.toString());
		}
		catch(Exception e)
		{
			fail("Error on clone"+e);
		}
	}
	
	public void testEquals()
	{
		System.out.println("testClone");
		try
		{
		Spectrum clone = (Spectrum)this.testSpectrum1.clone();
		System.out.println("clone:"+clone.getFragmentURI()+clone.getFragmentXPath());
		System.out.println("original:"+this.testSpectrum1.getFragmentURI()+this.testSpectrum1.getFragmentXPath());
		assertTrue("Failed: equals returned false",clone.equals(this.testSpectrum1));
		}
		catch(Exception e)
		{
			fail("Error on clone"+e);
		}
	}
	// TODO add test methods here, they have to start with 'test' name.
	// for example:
	// public void testHello() {}
	
	
}
