package it.polito.elite.doseWS.include;

import net.sf.snowball.*;
import java.lang.reflect.*;

public class Stemmer
{
  private SnowballProgram stemmer;
  private Method stemMethod;
  private String language;

  public Stemmer()
  {
    stemmer=null;
    stemMethod=null;
    language="";
  }

  public boolean initStemmer(String language)
  {
    try {
      Class stemClass =
          Class.forName("net.sf.snowball.ext." + language + "Stemmer");
      stemmer = (SnowballProgram) stemClass.newInstance();
      stemMethod = stemClass.getMethod("stem", new Class[0]);
    }
    catch (Exception e) {
      System.out.println(e);
      return false;
    }
    this.language=language;
    return true;

  }

  /** Stems a string according to a given language.
   * @param language The language to be used for stemming.
   * @param word The string to be stemmed.
   * @return The stemmed string.
   */
  public String stem(String word)
  {
    String stemmed = null;
    try {
      stemmed = word;
      stemmer.setCurrent(word);
      stemMethod.invoke(stemmer, new Object[0]);
      stemmed = stemmer.getCurrent();
    }
    catch (Exception ex) {
      System.out.println(ex);
    }
    return stemmed;
  }

  public String getLanguage()
  {
    return language;
  }

}