/*
 * Created on Oct 8, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.include;

/**
 * A class for representing synsets associated to ontology concepts
 * 
 * @author <a href="mailto:dario.bonino@polito.it">Dario Bonino</a>
 * <a href="mailto:alessio.bosca@polito.it">Alessio Bosca</a>
 * <a href="mailto:federico.pescarmona@polito.it">Federico Pescarmona</a>
 * <a href="mailto:michele.debandi@polito.it">Michele Debandi</a>
 *
 * @see the SynsetTest class for a testing class
 * @version 1.0
 * @since 11/2004
 */
public class Synset {
	
	private String conceptURI;
	private MWord mwords[];
	private String language;

	/**
	 * Constructor
	 * 
	 * @param conceptURI the URI of the concept to which this synset is
	 * associated
	 * 
	 * @param mwords the mwords composing the synset
	 * 
	 * @param lang the language of the sysnset
	 */
	public Synset(String conceptURI, MWord[] mwords, String language) {
		
		this.conceptURI = conceptURI;
		this.mwords = (MWord[])mwords.clone();
		this.language = language;
	}

	/**
	 * @return return the mword objects composing this synset
	 */
	public MWord[] getMWords() {
		return (MWord[])this.mwords.clone();
	}
	
	/**
	 * sets the mwords for this synset
	 * @param mwords the mword objects to be included in this synset (substitute the ones
	 * already stored)
	 */
	public void setMWords(MWord[] mwords)
	{
		this.mwords = (MWord[])mwords.clone();
	}

	/**
	 * @return the concept to which this synset is related
	 */
	public String getConcept() {
		return this.conceptURI;
	}

	/**
	 * @return the language of this synset
	 */
	public String getLanguage() {
		return this.language;
	}
	
	/**
	 * Serializes the synset according to a predefined XML format
	 * @return the XML serialization of this synset object
	 */
	public String serialize()
	{
		//creating xml serialization for the synset object
		StringBuffer serialized = new StringBuffer();
		
		//creating preamble
		serialized.append("<SYNSETENTRY lang=\""+this.language+"\">");
		
		//creating entries for mwords
		for(int i=0; i<(this.mwords).length; i++)			
			serialized.append(this.mwords[i].serialize());
	
		//creating closure
		serialized.append("</SYNSETENTRY>");
		
		return serialized.toString();
	}

}
