/*
 * Created on Sep 30, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.include;

/**
 * A class for storing the coverage of a given concept with respect to the indexed documents
 * 
 * @author <a href="mailto:dario.bonino@polito.it">Dario Bonino</a>
 * <a href="mailto:alessio.bosca@polito.it">Alessio Bosca</a>
 * <a href="mailto:federico.pescarmona@polito.it">Federico Pescarmona</a>
 * <a href="mailto:michele.debandi@polito.it">Michele Debandi</a>
 *
 * @version 1.0
 * @since 11/2004
 */
public class TopicFrequency {
	private String topicURI;
	private int topicFrequency;
	
	/**
	 * Constructor
	 * @param topicURI the URI of the concept for which is stored the coverage
	 * @param topicFrequency the coverage of such concept as the number of indexed
	 * resources referring to it
	 */
	public TopicFrequency(String topicURI, int topicFrequency)
	{
		this.topicURI = topicURI;
		this.topicFrequency = topicFrequency;
	}
	
	/**
	 * 
	 * @return the coverage of the concept stored in this object
	 */
	public int getFrequency()
	{
		return this.topicFrequency;
	}
	
	/**
	 * 
	 * @return the concept stored in this object
	 */
	public String getTopicURI()
	{
		return this.topicURI;
	}
	/**
	 * Sets the value of the coverage for this object
	 * @param frequency the coverage in terms of resources pointing at the topic
	 * stored in this object
	 */
	public void setFrequency(int frequency)
	{
		this.topicFrequency = frequency;
	}
	
	/**
	 * Sets the concept to which the coverage value refers
	 * @param uri the URI of the ontology concept
	 */
	public void setTopicURI(String uri)
	{
		this.topicURI = uri;
	}

}
