/*
 * AnnoRepository.java
 *
 * Created on July 12, 2004, 12:16 PM
 */

package it.polito.elite.doseWS.kernel;

import java.util.Hashtable;
import java.util.Vector;

/**
 * The interface defining the exported functionalities of the Annotation Repository
 *
 * @author  <a href="mailto:dario.bonino@polito.it">Dario Bonino</a>
 * <a href="mailto:alessio.bosca@polito.it">Alessio Bosca</a>
 * <a href="mailto:federico.pescarmona@polito.it">Federico Pescarmona</a>
 * <a href="mailto:michele.debandi@polito.it">Michele Debandi</a>
 * 
 * @version 1.0
 * @since 11/2004
 */
public interface AnnoRepository
{
	public int remove(String uri, String xPath, String author)throws Exception;
	
	public int addAnnotations(String fragmentURI, String fragmentXpath, Hashtable conceptURIandWeights, String author, String type)throws Exception;
	
	public int addAnnotation (String fragmentURI, String fragmentXpath, String conceptURI, double weight, String author, String type) throws Exception;
	
	//public int move (String originURI, String destinationURI, String author, String type);
	
	public Vector searchByTopic(Vector topicURIs, Vector authors, String type, double strict);
	
	public Vector reverseSearch(String fragmentURI, String fragmentXPath);
}
