/*
 * ExpanderImplTest.java
 * JUnit based test
 *
 * Created on July 8, 2004, 10:21 AM
 */

package it.polito.elite.doseWS.kernel;

import it.polito.elite.doseWS.include.*;
import it.polito.elite.doseWS.wrappers.Ontology;
import it.polito.elite.doseWS.wrappers.OntologyImpl;
import java.lang.Exception;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Set;
import junit.framework.*;

/**
 *
 * @author bonino
 */
public class ExpanderImplTest extends TestCase
{
	Spectrum testSpectrum;
	Expander expander;
	
	public ExpanderImplTest(java.lang.String testName)
	{
		super(testName);
		
		//creates the spectrum for the test using all concepts
		//that are roots for the hierarchy relationship
		Hashtable testVector = new Hashtable();
		Ontology onto = new OntologyImpl();
		Set roots = onto.getRoots();
		Iterator iter = roots.iterator();
		while(iter.hasNext())
			testVector.put((String)iter.next(),new Double(1.0));

		//build the test spectrum
		testSpectrum = new SpectrumImpl("uri1","Xpath1","Dario","junit",testVector);
		
		//create a new expander object
		expander = new ExpanderImpl();
	}
	
	public static void main(String args[]) {
		ExpanderImplTest test = new ExpanderImplTest("test expander");
		test.testInitExpander();
		test.testExpandResourceSpectrum();
		
	}
	
	public static Test suite()
	{
		TestSuite suite = new TestSuite(ExpanderImplTest.class);
		return suite;
	}
	
	/**
	 * Test of initExpander method, of class it.polito.elite.doseWS.kernel.ExpanderImpl.
	 */
	public void testInitExpander()
	{
		System.out.println("testInitExpander");
		
		// TODO add your test code below by replacing the default call to fail.
		
		try
		{
			ExpanderImpl.initExpander();
		}
		catch(Exception e)
		{
			fail("The Expander not inited\nError:"+e);
		}
		
	}
	
	/**
	 * Test of expandResourceSpectrum method, of class it.polito.elite.doseWS.kernel.ExpanderImpl.
	 */
	public void testExpandResourceSpectrum()
	{
		System.out.println("testExpandResourceSpectrum");
		
		// TODO add your test code below by replacing the default call to fail.
		Spectrum xSpectrum = expander.expandResourceSpectrum(testSpectrum);
		System.out.println("Expanded spectrum:\n"+xSpectrum.getConcepts().toString());
	}
	
	// TODO add test methods here, they have to start with 'test' name.
	// for example:
	// public void testHello() {}
	
	
}
