/*
 * Created on Sep 22, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.services;

import java.net.MalformedURLException;
import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Arrays;

import javax.xml.namespace.QName;
import javax.xml.rpc.Call;
import javax.xml.rpc.Service;
import javax.xml.rpc.ServiceException;
import javax.xml.rpc.ServiceFactory;

import it.polito.elite.doseWS.include.Spectrum;
import it.polito.elite.doseWS.include.SpectrumImpl;
import it.polito.elite.doseWS.include.SpectraRankComparator;



/**
 * @author bonino
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SearchEngineImpl implements SearchEngine {

	private static String annoEndpoint = "http://localhost:8080/axis/AnnoRepositoryWS.jws";
	private static String annoServer = "http://localhost:8080/";
	private static String expanderEndpoint = "http://localhost:8080/axis/ExpanderWS.jws";
	private static String expanderServer = "http://localhost:8080/";
	private static boolean ready = false;
	private static int nResults = 10;
	private static boolean debug = true;
	
	/* (non-Javadoc)
	 * @see it.polito.elite.doseWS.services.SearchEngine#search(java.util.Hashtable)
	 */
	
	public SearchEngineImpl()
	{
		
	}
	
	public static void initSearchEngine(String annoEndpoint, String annoServer,String expanderEndpoint, String expanderServer, int nResults) throws Exception
	{
		SearchEngineImpl.annoEndpoint = annoEndpoint;
		SearchEngineImpl.annoServer = annoServer;
		SearchEngineImpl.expanderEndpoint = expanderEndpoint;
		SearchEngineImpl.expanderServer = expanderServer;
		SearchEngineImpl.ready = true;
		SearchEngineImpl.nResults = nResults;
	}
	
	public String[] search(Hashtable topicURIandWeights, double strict) throws Exception{
		
		//as first creates a spectrum for the search request in order to
		//perform ranking
		Spectrum  querySpectrum = new SpectrumImpl("dummy","dummy","dummy","dummy",topicURIandWeights);
		
		System.out.println("SEARCH_ENGINE->Received query, sending expansion request...");
		long time = System.currentTimeMillis();
		
		Spectrum expandedSpectrum = this.sendExpansionRequest(querySpectrum);
		
		//debug/profiling
		time = System.currentTimeMillis()-time;
		System.out.println("SEARCH_ENGINE->Received expanded spectrum: Elapsed time-->"+time);
		
		//debug/profile
		System.out.println("SEARCH_ENGINE->Requesting data to the AnnoRepository...:");
		time = System.currentTimeMillis();
		
		//send the query to the annotation service
		Spectrum[] retrievedSpectra = this.sendAnnoRequest(expandedSpectrum, strict);
		
		//debug/profiling
		time = System.currentTimeMillis()-time;
		System.out.println("SEARCH_ENGINE->Received data from AnnoRepository: Elapsed time-->"+time);
		
		//debug/profiling
		System.out.println("SEARCH_ENGINE->Starting ranking...");
		time = System.currentTimeMillis();
		
		//result ranking
		Spectrum[] rankedResults = this.rank(retrievedSpectra, querySpectrum);
		
		
		//debug/profiling
		time = System.currentTimeMillis()-time;
		System.out.println("SEARCH_ENGINE->Ended ranking: Elapsed time-->"+time);
		
		
		//Extracting URIs
		String uris[] = new String[10]; //rankedResults.length
		//loading URIs
		for(int i=0; i<10; i++)
		{
			uris[i] = rankedResults[i].getFragmentURI();//+rankedResults[i].getFragmentXPath();
		}
		
		return uris;
	}
	
	private Spectrum[] rank(Spectrum spectraSet[],Spectrum querySpectrum)
	{
		//sorts the spectra Array
		Arrays.sort(spectraSet,new SpectraRankComparator(querySpectrum));
		//return the sorted set
		return spectraSet;
	}
	
	private Spectrum[] sendAnnoRequest(Spectrum query, double strict) throws Exception
	{
		//array of serialized spectra to be filled by data retrieved
		//from the annotation repository
		String serializedResult[]= new String[0];
		
		//array of spectra to be filled by data deSerialized from
		//the serializedResult array
		Spectrum result[]= new Spectrum[0];
		
		//try to send the request to the annotation service
		try
		{
			//extract the query topics
			Hashtable conceptsAndWeights = query.getConcepts();
			
			//compose the topic vector to be passed to the annotation repository
			Enumeration topicURIs = conceptsAndWeights.keys();
			String topics[] = new String[conceptsAndWeights.size()];
			int i=0;
			while(topicURIs.hasMoreElements())
			{
				topics[i]=(String)topicURIs.nextElement();
				i++;
			}
			
			//creates a new QName identifier for the annotation service "http://localhost:8080/"
			QName op =new QName(SearchEngineImpl.annoServer,"searchByTopic"); 
			
			//creating service factory
			ServiceFactory factory  = ServiceFactory.newInstance();
			
			//defining the service
			Service service = factory.createService(new QName("AnnoRepositoryWSService"));
			
			//defining the service port
			QName port = new QName("AnnoRepositoryWS");
				
			//creating the call object
			Call call = service.createCall(port);
	
			if(debug) System.out.println("DEBUG: created communication stub");
			
			//sets the endpoint for the call
			call.setTargetEndpointAddress(SearchEngineImpl.annoEndpoint);
				
			//sets the operation to be required by the call
			call.setOperationName(op);
			
			//creates the placeholder for remote method params
			Object params[] = new Object[4];
			
			//adds the required parameter: a serialized spectrum
			params[0] = (Object) topics;
			params[1] = (Object) new String[]{"default"};
			params[2] = (Object) new String("default");
			params[3] = (Object) new Double (strict);
			//invokes the remote service
			if(debug) System.out.println("DEBUG: invoking the annotation service");
			serializedResult = (String[]) call.invoke(params);
		}
		catch(Exception e)
		{
			String error;
			e.printStackTrace();
			if(e instanceof RemoteException)
			{
				error = "Error invoking the annotation Repository web service: ";
				error += e;
				throw new Exception (error);
			}
			if(e instanceof ServiceException)
			{
				error = "Error creating the call to the annotation Repository web service: ";
				error += e;
				throw new Exception (error);
			}
			if(e instanceof MalformedURLException)
			{
				error = "Error on the annotation Repository end point: ";
				error += e;
				throw new Exception (error);
			}
		}
		
		//if comes here all is ok
		
		//set the correct result size
		result = new Spectrum[serializedResult.length];
		//load the result array
		for(int i=0; i<serializedResult.length; i++)
			result[i]=(Spectrum)(SpectrumImpl.deSerialize(serializedResult[i]));
		//return results
		return result;
	}


	private Spectrum sendExpansionRequest(Spectrum spectrum)throws Exception
	{
		//the placeholder for the expanded spectrum
		String serializedXSpectrum = "";
		
		//serializing the spectrum for trasmission over SOAP
		String serializedSpectrum = ((SpectrumImpl) spectrum).serialize();
	
		if(debug) System.out.println("DEBUG: trying to create communication stub");
		
		//trying to invoke the Expander service
		try
		{
			// creates a new QName identifier for the expansion service "http://localhost:8080/"
			QName op =new QName(SearchEngineImpl.expanderServer,"expandResourceSpectrum"); 
			
			//creating service factory
			ServiceFactory factory  = ServiceFactory.newInstance();
			
			//defining the service
			Service service = factory.createService(new QName("ExpanderWSService"));
			
			//defining the service port
			QName port = new QName("ExpanderWS");
		
			//creating the call object
			Call call = service.createCall(port);
		
			if(debug) System.out.println("DEBUG: created communication stub");
			
			//sets the endpoint for the call "http://localhost:8080/axis/ExpanderWS.jws"
			call.setTargetEndpointAddress(SearchEngineImpl.expanderEndpoint);
		
			//sets the operation to be required by the call
			call.setOperationName(op);
			
			//creates the placeholder for remote method params
			Object params[] = new Object[1];
			
			//adds the required parameter: a serialized spectrum
			params[0]= (Object)serializedSpectrum;
			
			//invokes the remote service
			if(debug) System.out.println("DEBUG: invoking the expander service");
			serializedXSpectrum = (String) call.invoke(params);
		}
		catch (Exception e)
		{
			String error;
			e.printStackTrace();
			if(e instanceof RemoteException)
			{
				error = "Error invoking the expander web service: ";
				error += e;
				throw new Exception (error);
			}
			if(e instanceof ServiceException)
			{
				error = "Error creating the call to the expander web service: ";
				error += e;
				throw new Exception (error);
			}	
			if(e instanceof MalformedURLException)
			{
				error = "Error on the Expander end point: ";
				error += e;
				throw new Exception (error);
			}
		}
		//deserialize the expanded spectrum
		Spectrum expandedSpectrum = (Spectrum)SpectrumImpl.deSerialize(serializedXSpectrum);
	
		return expandedSpectrum;
	}
	public static boolean isReady()
	{
		return SearchEngineImpl.ready;
	}
}
