/*
 * Created on Dec 21, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.test;

import it.polito.elite.doseWS.include.Spectrum;
import it.polito.elite.doseWS.include.SpectrumImpl;
import it.polito.elite.doseWS.include.TopicViewer;

import it.polito.elite.doseWS.wrappers.Ontology;
import it.polito.elite.doseWS.wrappers.OntologyImpl;

import java.io.BufferedReader;
import java.io.FileReader;
import java.net.MalformedURLException;
import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Set;



import javax.xml.namespace.QName;
import javax.xml.rpc.Call;
import javax.xml.rpc.Service;
import javax.xml.rpc.ServiceException;
import javax.xml.rpc.ServiceFactory;

import org._3pq.jgrapht.Edge;
import org._3pq.jgrapht.edge.EdgeFactories.UndirectedWeightedEdgeFactory;
import org._3pq.jgrapht.graph.SimpleWeightedGraph;
import org._3pq.jgrapht.traverse.DepthFirstIterator;

/**
 * @author bonino
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AnnotationVisualizer {

	/**
	 * 
	 */
	
	//the array of ontology concepts
	private static String[] topicSet;
	
	//the size of the ontology
	private static int ontoSize = 0;
	
	//the Annotation Repository EndPoint
	private static String annoEndpoint = "http://corburant.polito.it:8080/axis/AnnoRepositoryWS.jws";
	
	//the Annotation Repository 
	private static String annoServer = "http://corburant.polito.it:8080/";
	
	public AnnotationVisualizer() throws Exception
	{
		super();

		//Loading the ontology
		Ontology ontology = new OntologyImpl("http://corburant.polito.it:8080/axis/ontology.owl", true);
		
		//preparing the ontology graph
		SimpleWeightedGraph ontologyGraph = new SimpleWeightedGraph();
		
		//initializing the ontology graph
		AnnotationVisualizer.initGraph(ontology,ontologyGraph);
		
		//initializing the hierarchy relations in the graph
		AnnotationVisualizer.initHierarchy(ontology,ontologyGraph, 0.5);
		
		//initializing the topics depth-first
		AnnotationVisualizer.initTopicsDepthFirst(ontology, ontologyGraph);

	}
	
	private static void initGraph(Ontology onto, SimpleWeightedGraph graph)
	{
		//as First get all ontology concepts
		Iterator allClasses = onto.getAllClasses().iterator();
		
		//counter
		int i=0;
		
		//loads all graph vertices
		while(allClasses.hasNext())
		{
			//add the ontology concepts to the graph
			graph.addVertex((String)allClasses.next());
			i++;
		}
		
		//sets the ontology size
		AnnotationVisualizer.ontoSize = i+1;
		
		System.out.println("Ontosize: "+AnnotationVisualizer.ontoSize);
	}
	
	private static void initHierarchy(Ontology onto, SimpleWeightedGraph graph, double isAWeight) throws Exception
	{
		try
		{
			//inits the ontology graph adding hierarchy relations between concepts
			
			//get all ontology concepts
			Set ontoNodes = graph.vertexSet();
						
			Iterator ontoNodesIterator = ontoNodes.iterator();
			
			//initialize the edge factory for adding edges to the ontology graph
			UndirectedWeightedEdgeFactory factory = new UndirectedWeightedEdgeFactory();
			
			//add hierarchy relationships
			while(ontoNodesIterator.hasNext())
			{
				//first concept
				String originConcept = (String) ontoNodesIterator.next();
				
				//System.err.println("Original concept:"+originConcept);
				
				//get all subclasses of the origin topic
				Iterator subClasses = onto.getSubClasses(originConcept);
				
				//add isA edges
				while(subClasses.hasNext())
				{
					//isA possess the maximum weight,
					//edges weight are defined as exp(relWeight), in that way propagation can
					//be computed as the log of the sum of edges weights between two
					//concepts
					
					//creating edge
					Edge isA = factory.createEdge(originConcept, (String)subClasses.next());
					//assigning edge value
					isA.setWeight(1.0/isAWeight);
					//adding edge to graph
					graph.addEdge(isA);
					//System.err.println("Added edge:"+isA.toString());
				}
			}
		}
		catch(Exception e)
		{
			throw new Exception("Error on expander isA init");
		}
		
		
	}
	
	private static void initTopicsDepthFirst(Ontology onto, SimpleWeightedGraph graph)
	{
		//initializes the topic set
		AnnotationVisualizer.topicSet = new String [AnnotationVisualizer.ontoSize];
				
		//extract all roots
		Set rootSet = onto.getRoots();
		
		//getting an Iterator from the root set
		Iterator iter = rootSet.iterator();
		
		//topic counter
		int i=0;
		
		while(iter.hasNext())
		{
			//the current root topic
			String topic = (String) iter.next();
			
			//adding the current root topic
			AnnotationVisualizer.topicSet[i]=topic;
			
			//updating the topic counter
			i++;
			
			//debug
			System.out.println("Root ["+i+"]: "+topic);
			
			//getting a depth first iterator over the isA relationships
			DepthFirstIterator bIter = new DepthFirstIterator(graph,topic);
			
			//while there are nodes
			while (bIter.hasNext())
			{
				//the current ontology node
				String child = bIter.next().toString();
				
				//if the node is not a root
				if(!topic.equalsIgnoreCase("root")&&(!child.equalsIgnoreCase(topic)))
				{
					//searches for duplicates
					boolean found = false;
					for(int j=0; (j < i)&&(!found); j++)
					{
						if(AnnotationVisualizer.topicSet[j].equalsIgnoreCase(child))
						{
							found=true;
						}
					}
					if(!found)
					{
						//add the topic to the topic set
						AnnotationVisualizer.topicSet[i] = child;
					
						//debug
						System.out.println("\tChild ["+i+"]: "+child);
					
						//update counter
						i++;
					}
				}
				
			}
		}
	}

	private Spectrum sendAnnoRequest(String url) throws Exception
	{
		//array of serialized spectra to be filled by data retrieved
		//from the annotation repository
		String serializedResult = new String();
		
		//array of spectra to be filled by data deSerialized from
		//the serializedResult array
		Spectrum result;
		
		//try to send the request to the annotation service
		try
		{
						
			//creates a new QName identifier for the annotation service "http://localhost:8080/"
			QName op =new QName(AnnotationVisualizer.annoServer,"getSpectrum"); 
			
			//creating service factory
			ServiceFactory factory  = ServiceFactory.newInstance();
			
			//defining the service
			Service service = factory.createService(new QName("AnnoRepositoryWSService"));
			
			//defining the service port
			QName port = new QName("AnnoRepositoryWS");
				
			//creating the call object
			Call call = service.createCall(port);
	
			System.out.println("DEBUG: created communication stub");
			
			//sets the endpoint for the call
			call.setTargetEndpointAddress(AnnotationVisualizer.annoEndpoint);
				
			//sets the operation to be required by the call
			call.setOperationName(op);
			
			//creates the placeholder for remote method params
			Object params[] = new Object[2];
			
			//adds the required parameter: a serialized spectrum
			params[0] = (Object) new String(url);
			params[1] = (Object) new String("/html/body");
			
			//invokes the remote service
			//System.out.println("DEBUG: invoking the annotation service");
			serializedResult = (String) call.invoke(params);
		}
		catch(Exception e)
		{
			String error;
			e.printStackTrace();
			if(e instanceof RemoteException)
			{
				error = "Error invoking the annotation Repository web service: ";
				error += e;
				throw new Exception (error);
			}
			if(e instanceof ServiceException)
			{
				error = "Error creating the call to the annotation Repository web service: ";
				error += e;
				throw new Exception (error);
			}
			if(e instanceof MalformedURLException)
			{
				error = "Error on the annotation Repository end point: ";
				error += e;
				throw new Exception (error);
			}
		}
		
		//if comes here all is ok
		result =(Spectrum)(SpectrumImpl.deSerialize(serializedResult));
		
		//System.out.println("Received:"+result.getConcepts().toString());
		//return results
		return result;
	}
	
	public void visualize(String url, String filename)throws Exception
	{
		//gets the spectrum corresponding to the url
		Spectrum spectrum = this.sendAnnoRequest(url);
		
		//debug
		//System.out.println("received"+((SpectrumImpl)spectrum).serialize());
		
		//extract the weights in the order given by the topicSet Set
		
		//prepares the weights set
		Double weights[] = new Double[AnnotationVisualizer.topicSet.length];
		
		//extract the topics and weights from the spectrum
		Hashtable topicsAndWeights = spectrum.getConcepts();
		
		//for each topic in the spectrum
		for(int i=0; i<AnnotationVisualizer.topicSet.length; i++)
		{
			//extract the topic
			String topic = AnnotationVisualizer.topicSet[i];
			
			//initializes the weight at 0
			Double weight = new Double(0.0);
			try
			{
				//if the topic is in the spectrum, extract the weight
				 weight = (Double)topicsAndWeights.get(topic);
			}
			catch(Exception e){};
			
			if(weight == null) weight = new Double(0.0);
			
			//debug
			//System.out.println ("extracted "+topic+" weight: "+weight);
			
			//get the corresponding weight and stores it into the data set
			weights[i] = weight;
		}
		
		//view the spectrum:
		
		//istantiates a topic viewer
		TopicViewer viewSpectrum = new TopicViewer();
		
		//debug
		//System.out.println("TopicViewer: "+viewSpectrum.toString());
		
		//setting labels
		viewSpectrum.setNames(AnnotationVisualizer.topicSet);
		
		//setting data
		viewSpectrum.setData(weights);
		
		//setting doc url
		viewSpectrum.setCurrentSpectrumURI(url);
		
		//creates a new ontology graph
		viewSpectrum.createChart();
		
		//showing data
		//viewSpectrum.show();
		
		//saving data
		viewSpectrum.saveChart(filename);
		
	}
			

	public static void main(String[] args) {
		try 
		{
			//Istantiates a visualizer object
			AnnotationVisualizer annoViz = new AnnotationVisualizer();
			
			//the file where the urls are stored
			String fileName="E:/HDOSE/hdose_tests/altralista.txt";
			
			//as first builds a reader for the urls file
			BufferedReader br=new BufferedReader(new FileReader(fileName));
			
			//reads the url until the file is not empty or until the limit fixed by i has been reached
			int i=0;
			while((br.ready())&&(i<2000))
			{
				String url=br.readLine();
				System.out.println("URI ["+i+"]: "+url);
				try
				{
					annoViz.visualize(url,"E:/HDOSE/hdose_tests/images/test_hdose_"+i+".png");
				}
				catch (Exception ex)
				{
					System.out.println(ex.toString());
					continue;
				}
				finally 
				{
					i++;
				}
			}
			
		} 
		catch (Exception e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
