package it.polito.elite.doseWS.test;

import java.util.*;
import it.polito.elite.doseWS.wrappers.*;

public class OntologyImplTest {
	long time1, time2;
	OntologyImpl ont;
	public OntologyImplTest() {
		ont = new OntologyImpl("files/ontology/ontoPescar.owl", false);
		//ont = new OntologyImpl("files/ontology/ontology.owl", false);
		time1 = System.currentTimeMillis();
		System.out.println(time1);
		System.out.println("Testing roots");
		testRoots();
		System.out.println("Testing all classes");
		testGetAllClasses();
		System.out.println("Testing all relations");
		testAllRelations();
		System.out.println("Testing relation");
		testRelationEnds();
		System.out.println("Testing definition and title");
		testDefinitionAndTitle();
	}
	
	public static void main(String args[]) {
		new OntologyImplTest();
	}
	
	private void testRoots() {
		Set roots = ont.getRoots();
		time2 = System.currentTimeMillis();
		System.out.println(roots.toString());
		System.out.println(time2-time1);
		time1 = System.currentTimeMillis();
		roots = ont.getRoots();
		System.out.println(roots.toString());
		time2 = System.currentTimeMillis();
		System.out.println(time1-time2);
	}
	
	private void testGetAllClasses() {
		Iterator iter = ont.getAllClasses().iterator();
		while(iter.hasNext()) {
			System.out.println(iter.next().toString());
		}
		time2 = System.currentTimeMillis();
		System.out.println(time2-time1);
		time1 = System.currentTimeMillis();
		iter = ont.getAllClasses().iterator();
		while(iter.hasNext()) {
			System.out.println(iter.next().toString());
		}
		time2 = System.currentTimeMillis();
		System.out.println(time2-time1);
	}
	
	private void testAllRelations() {
		Hashtable ht = ont.getAllRelations();
		time2 = System.currentTimeMillis();
		System.out.println(ht.toString());
		System.out.println(time2-time1);
		time1 = System.currentTimeMillis();
		ht = ont.getAllRelations();
		System.out.println(ht.toString());
		time2 = System.currentTimeMillis();
		System.out.println(time1-time2);
	}
	
	private void testRelationEnds() {
		Iterator iter = ont.getRelationEnds("http://a.com/ontology#ente", "http://a.com/ontology#provides").iterator();
		while(iter.hasNext())
			System.out.println(iter.next().toString());
	}
	
	private void testDefinitionAndTitle() {
		System.out.println(ont.getDefinition("http://a.com/ontology#ente","en"));
		System.out.println(ont.getTitle("http://a.com/ontology#servizio","it"));
	}
}