/*
 * DBWrapperImplTest.java
 * JUnit based test
 *
 * Created on July 12, 2004, 2:23 PM
 */

package it.polito.elite.doseWS.wrappers;

import java.util.*;
import it.polito.elite.doseWS.include.*;
import junit.framework.*;


/**
 *
 * @author debandi
 */
public class DBWrapperImplTest extends TestCase {


    private static final String[] topics = {
	"http://elite.polito.it/disabilita`#Caratteristiche di strutture e spazi",
	"http://elite.polito.it/disabilita`#Usabilita`",
	"http://elite.polito.it/disabilita`#Accessibilita`",
	"http://elite.polito.it/disabilita`#Visitabilita`",
	"http://elite.polito.it/disabilita`#Adattabilita`",
	"http://elite.polito.it/disabilita`#Barriere architettoniche",
	"http://elite.polito.it/disabilita`#Punto di chiamata",
	"http://elite.polito.it/disabilita`#Permesso di libera sosta e circolazione",
	"http://elite.polito.it/disabilita`#Area metropolitana",
	"http://elite.polito.it/disabilita`#Mezzo di trasporto",
	"http://elite.polito.it/disabilita`#Aeroplano",
	"http://elite.polito.it/disabilita`#Motociclo",
	"http://elite.polito.it/disabilita`#Tram",
	"http://elite.polito.it/disabilita`#Treno",
	"http://elite.polito.it/disabilita`#Metropolitana",
	"http://elite.polito.it/disabilita`#Metropolitana leggera",
	"http://elite.polito.it/disabilita`#Mezzo ferrato",
	"http://elite.polito.it/disabilita`#Autobus",
	"http://elite.polito.it/disabilita`#Autobus attrezzato",
	"http://elite.polito.it/disabilita`#Minibus attrezzato",
	"http://elite.polito.it/disabilita`#Autoambulanza",
	"http://elite.polito.it/disabilita`#Mezzo attrezzato",
	"http://elite.polito.it/disabilita`#Minibus",
	"http://elite.polito.it/disabilita`#Automobile",
	"http://elite.polito.it/disabilita`#Camper",
	"http://elite.polito.it/disabilita`#Autocaravan",
	"http://elite.polito.it/disabilita`#Taxi",
	"http://elite.polito.it/disabilita`#Automezzo",
	"http://elite.polito.it/disabilita`#Roulotte",
	"http://elite.polito.it/disabilita`#Nave",
	"http://elite.polito.it/disabilita`#Traghetto",
	"http://elite.polito.it/disabilita`#Aliscafo",
	"http://elite.polito.it/disabilita`#Mezzo di trasporto aereo",
	"http://elite.polito.it/disabilita`#Mezzo di trasporto terrestre",
	"http://elite.polito.it/disabilita`#Mezzo di trasporto navale",
	"http://elite.polito.it/disabilita`#Documenti e servizi gestiti dalla Motorizzazione",
	"http://elite.polito.it/disabilita`#Immatricolazione",
	"http://elite.polito.it/disabilita`#Revisione auto",
	"http://elite.polito.it/disabilita`#Collaudo",
	"http://elite.polito.it/disabilita`#Carta di circolazione",
	"http://elite.polito.it/disabilita`#Beneficenza",
	"http://elite.polito.it/disabilita`#Donazione",
	"http://elite.polito.it/disabilita`#Forum permanente del terzo settore",
	"http://elite.polito.it/disabilita`#Competenze",
	"http://elite.polito.it/disabilita`#Abilita` lavorative",
	"http://elite.polito.it/disabilita`#Competenze di base",
	"http://elite.polito.it/disabilita`#Competenze trasversali",
	"http://elite.polito.it/disabilita`#Competenze professionali",
	"http://elite.polito.it/disabilita`#Know how",
	"http://elite.polito.it/disabilita`#Competenze relazionali",
	"http://elite.polito.it/disabilita`#Adattamenti e modifiche",
	"http://elite.polito.it/disabilita`#Disabilita`",
	"http://elite.polito.it/disabilita`#Centro di mobilita`",
	"http://elite.polito.it/disabilita`#Idoneita` alla guida",
	"http://elite.polito.it/disabilita`#Prestazioni indennitarie",
	"http://elite.polito.it/disabilita`#Indennita` di accompagnamento",
	"http://elite.polito.it/disabilita`#Indennita` integrativa speciale",
	"http://elite.polito.it/disabilita`#Indennita` di mobilita`",
	"http://elite.polito.it/disabilita`#Indennita`",
	"http://elite.polito.it/disabilita`#Rendita per inabilita` permanente",
	"http://elite.polito.it/disabilita`#Assegno mensile",
	"http://elite.polito.it/disabilita`#Pensione di guerra",
	"http://elite.polito.it/disabilita`#Soggetto beneficiario",
	"http://elite.polito.it/disabilita`#Cecita` civile totale",
	"http://elite.polito.it/disabilita`#Cecita` civile parziale",
	"http://elite.polito.it/disabilita`#Sordita` civile",
	"http://elite.polito.it/disabilita`#Invalidita` del lavoro",
	"http://elite.polito.it/disabilita`#Cecita` del lavoro",
	"http://elite.polito.it/disabilita`#Cecita` di guerra",
	"http://elite.polito.it/disabilita`#Invalidita` civile",
	"http://elite.polito.it/disabilita`#Invalidita` di guerra",
	"http://elite.polito.it/disabilita`#Cecita` civile",
	"http://elite.polito.it/disabilita`#Centro servizi per il volontariato",
	"http://elite.polito.it/disabilita`#Anzianita` di iscrizione",
	"http://elite.polito.it/disabilita`#Graduatorie",
	"http://elite.polito.it/disabilita`#Menomazione",
	"http://elite.polito.it/disabilita`#Pluriminorazione",
	"http://elite.polito.it/disabilita`#Sordomutismo",
	"http://elite.polito.it/disabilita`#Sordita`",
	"http://elite.polito.it/disabilita`#Cecita`",
	"http://elite.polito.it/disabilita`#Difetto di riduzione degli arti",
	"http://elite.polito.it/disabilita`#Compromissione funzionale",
	"http://elite.polito.it/disabilita`#Equo indennizzo",
	"http://elite.polito.it/disabilita`#Lesione",
	"http://elite.polito.it/disabilita`#Azione di regresso",
	"http://elite.polito.it/disabilita`#Valutazione",
	"http://elite.polito.it/disabilita`#Valutazione di processo",
	"http://elite.polito.it/disabilita`#Valutazione dei risultati",
	"http://elite.polito.it/disabilita`#Valutazione di sistema",
	"http://elite.polito.it/disabilita`#Monitoraggio",
	"http://elite.polito.it/disabilita`#Assessment",
	"http://elite.polito.it/disabilita`#Assistenza sociale",
	"http://elite.polito.it/disabilita`#Convenzione",
	"http://elite.polito.it/disabilita`#Conto stato",
	"http://elite.polito.it/disabilita`#Bacino di utenza",
	"http://elite.polito.it/disabilita`#Trasporto",
	"http://elite.polito.it/disabilita`#Trasporto pubblico regionale e locale",
	"http://elite.polito.it/disabilita`#Linea extraurbana",
	"http://elite.polito.it/disabilita`#Linea urbana",
	"http://elite.polito.it/disabilita`#Trasporto di linea",
	"http://elite.polito.it/disabilita`#Trasporto pubblico nazionale",
	"http://elite.polito.it/disabilita`#Trasporto privato",
	"http://elite.polito.it/disabilita`#Trasporto pubblico",
	"http://elite.polito.it/disabilita`#Impatto",
	"http://elite.polito.it/disabilita`#Liste di attesa",
	"http://elite.polito.it/disabilita`#Famiglia",
	"http://elite.polito.it/disabilita`#Famiglia multiproblematica",
	"http://elite.polito.it/disabilita`#Filiazione",
	"http://elite.polito.it/disabilita`#Filiazione legittima",
	"http://elite.polito.it/disabilita`#Filiazione ignota",
	"http://elite.polito.it/disabilita`#Filiazione naturale",
	"http://elite.polito.it/disabilita`#Assicurazione",
	"http://elite.polito.it/disabilita`#Carta verde",
	"http://elite.polito.it/disabilita`#RC auto",
	"http://elite.polito.it/disabilita`#Requisiti per il diritto di pensione",
	"http://elite.polito.it/disabilita`#Anzianita` contributiva",
	"http://elite.polito.it/disabilita`#Contribuzione",
	"http://elite.polito.it/disabilita`#Anzianita`",
	"http://elite.polito.it/disabilita`#Pensione",
	"http://elite.polito.it/disabilita`#Pensione di reversibilita`",
	"http://elite.polito.it/disabilita`#Pensione indiretta",
	"http://elite.polito.it/disabilita`#Pensione ai superstiti",
	"http://elite.polito.it/disabilita`#Maggiorazione sociale",
	"http://elite.polito.it/disabilita`#Pensione di vecchiaia",
	"http://elite.polito.it/disabilita`#Pensione di annata",
	"http://elite.polito.it/disabilita`#Pensione supplementare",
	"http://elite.polito.it/disabilita`#Pensione di anzianita`",
	"http://elite.polito.it/disabilita`#Pensione di inabilita`",
	"http://elite.polito.it/disabilita`#Pensione di invalidita`",
	"http://elite.polito.it/disabilita`#Trattamento minimo",
	"http://elite.polito.it/disabilita`#Assegni sociali",
	"http://elite.polito.it/disabilita`#Pensione previdenziale",
	"http://elite.polito.it/disabilita`#Trattamento di quiescenza",
	"http://elite.polito.it/disabilita`#Pensione di benemerenza",
	"http://elite.polito.it/disabilita`#Ricostituzione",
	"http://elite.polito.it/disabilita`#Pensione assistenziale",
	"http://elite.polito.it/disabilita`#Convenzioni per li inserimento lavorativo",
	"http://elite.polito.it/disabilita`#Notifica",
	"http://elite.polito.it/disabilita`#Profilo socio-lavorativo della persona disabile",
	"http://elite.polito.it/disabilita`#IADL",
	"http://elite.polito.it/disabilita`#Prestazioni di invalidita` civile ed assimilate",
	"http://elite.polito.it/disabilita`#Domanda",
	"http://elite.polito.it/disabilita`#Servizio",
	"http://elite.polito.it/disabilita`#Servizio di accompagnamento ai seggi elettorali",
	"http://elite.polito.it/disabilita`#Servizio di accompagnamento",
	"http://elite.polito.it/disabilita`#Servizio di trasporto",
	"http://elite.polito.it/disabilita`#Servizio di cortesia",
	"http://elite.polito.it/disabilita`#Centro di assistenza",
	"http://elite.polito.it/disabilita`#Servizio di accoglienza",
	"http://elite.polito.it/disabilita`#Informahandicap",
	"http://elite.polito.it/disabilita`#Servizio pubblico",
	"http://elite.polito.it/disabilita`#Servizio per i trasporti",
	"http://elite.polito.it/disabilita`#Prenotazione",
	"http://elite.polito.it/disabilita`#Informazioni",
	"http://elite.polito.it/disabilita`#Superstiti",
	"http://elite.polito.it/disabilita`#Collaterali",
	"http://elite.polito.it/disabilita`#PRA",
	"http://elite.polito.it/disabilita`#Certificato di proprieta`",
	"http://elite.polito.it/disabilita`#IPT",
	"http://elite.polito.it/disabilita`#Equipaggiamento",
	"http://elite.polito.it/disabilita`#Elevatore",
	"http://elite.polito.it/disabilita`#Presa in carico",
	"http://elite.polito.it/disabilita`#Handicap",
	"http://elite.polito.it/disabilita`#Traumatismo",
	"http://elite.polito.it/disabilita`#Diagnosi funzionale della persona disabile",
	"http://elite.polito.it/disabilita`#Collocamento mirato",
	"http://elite.polito.it/disabilita`#Anagrafe",
	"http://elite.polito.it/disabilita`#Danni da lavoro",
	"http://elite.polito.it/disabilita`#Infortunio in itinere",
	"http://elite.polito.it/disabilita`#Morte",
	"http://elite.polito.it/disabilita`#Inabilita` temporanea",
	"http://elite.polito.it/disabilita`#Inabilita` permanente",
	"http://elite.polito.it/disabilita`#Infortunio sul lavoro indennizzato INAIL",
	"http://elite.polito.it/disabilita`#Infortunio sul lavoro",
	"http://elite.polito.it/disabilita`#Infortunio",
	"http://elite.polito.it/disabilita`#Malattia professionale",
	"http://elite.polito.it/disabilita`#Tassa automobilistica",
	"http://elite.polito.it/disabilita`#Bollo auto",
	"http://elite.polito.it/disabilita`#Riccometro",
	"http://elite.polito.it/disabilita`#Condizione professionale",
	"http://elite.polito.it/disabilita`#Lavori di pubblica utilita`",
	"http://elite.polito.it/disabilita`#Autoimpiego",
	"http://elite.polito.it/disabilita`#Franchising",
	"http://elite.polito.it/disabilita`#Consulenza professionale",
	"http://elite.polito.it/disabilita`#Contratto di collaborazione occasionale",
	"http://elite.polito.it/disabilita`#Contratto di collaborazione coordinata e continuativa",
	"http://elite.polito.it/disabilita`#Contratto di collaborazione",
	"http://elite.polito.it/disabilita`#Contratti di lavoro atipici",
	"http://elite.polito.it/disabilita`#Lavoro parasubordinato",
	"http://elite.polito.it/disabilita`#Lavoro autonomo",
	"http://elite.polito.it/disabilita`#Contratto individuale di lavoro",
	"http://elite.polito.it/disabilita`#Lavori socialmente utili",
	"http://elite.polito.it/disabilita`#Lavoro interinale",
	"http://elite.polito.it/disabilita`#Contratto a tempo determinato",
	"http://elite.polito.it/disabilita`#Contratto di formazione lavoro",
	"http://elite.polito.it/disabilita`#Apprendistato",
	"http://elite.polito.it/disabilita`#Contratto collettivo di lavoro",
	"http://elite.polito.it/disabilita`#Contratto part-time ciclico",
	"http://elite.polito.it/disabilita`#Contratto part-time verticale",
	"http://elite.polito.it/disabilita`#Contratto part-time orizzontale",
	"http://elite.polito.it/disabilita`#Contratto a tempo parziale",
	"http://elite.polito.it/disabilita`#Contratto di solidarieta`",
	"http://elite.polito.it/disabilita`#Lavoro dipendente",
	"http://elite.polito.it/disabilita`#Occupazione precaria",
	"http://elite.polito.it/disabilita`#Telelavoro",
	"http://elite.polito.it/disabilita`#Job sharing",
	"http://elite.polito.it/disabilita`#Congedo matrimoniale",
	"http://elite.polito.it/disabilita`#Congedo di maternita`",
	"http://elite.polito.it/disabilita`#Congedo per adozione",
	"http://elite.polito.it/disabilita`#Congedo per motivi familiari",
	"http://elite.polito.it/disabilita`#Congedo di paternita`",
	"http://elite.polito.it/disabilita`#Congedo parentale",
	"http://elite.polito.it/disabilita`#Disoccupazione",
	"http://elite.polito.it/disabilita`#Aspettativa",
	"http://elite.polito.it/disabilita`#Lavoro",
	"http://elite.polito.it/disabilita`#Congedo",
	"http://elite.polito.it/disabilita`#Piano degli interventi e dei servizi sociali",
	"http://elite.polito.it/disabilita`#Piano sociale di zona",
	"http://elite.polito.it/disabilita`#Piano nazionale",
	"http://elite.polito.it/disabilita`#Piano regionale",
	"http://elite.polito.it/disabilita`#Fondo nazionale per le politiche sociali",
	"http://elite.polito.it/disabilita`#Inabilita`",
	"http://elite.polito.it/disabilita`#Prestazioni di invalidita`",
	"http://elite.polito.it/disabilita`#Invalidita`",
	"http://elite.polito.it/disabilita`#Problemi sul lavoro",
	"http://elite.polito.it/disabilita`#Segregazione occupazionale orizzontale",
	"http://elite.polito.it/disabilita`#Segregazione occupazionale verticale",
	"http://elite.polito.it/disabilita`#Segregazione occupazionale",
	"http://elite.polito.it/disabilita`#Discriminazione diretta",
	"http://elite.polito.it/disabilita`#Discriminazione indiretta",
	"http://elite.polito.it/disabilita`#Discriminazione",
	"http://elite.polito.it/disabilita`#Differenza retributiva tra i sessi",
	"http://elite.polito.it/disabilita`#Mobbing",
	"http://elite.polito.it/disabilita`#Disparita` di genere",
	"http://elite.polito.it/disabilita`#PMR",
	"http://elite.polito.it/disabilita`#MEDIF",
	"http://elite.polito.it/disabilita`#Domanda di lavoro",
	"http://elite.polito.it/disabilita`#Flotta",
	"http://elite.polito.it/disabilita`#Inserimento lavorativo",
	"http://elite.polito.it/disabilita`#Intermediazione tra domanda ed offerta di lavoro",
	"http://elite.polito.it/disabilita`#Borsa lavoro",
	"http://elite.polito.it/disabilita`#Stage",
	"http://elite.polito.it/disabilita`#Assunzione",
	"http://elite.polito.it/disabilita`#Tirocinio",
	"http://elite.polito.it/disabilita`#Mediazione tra domanda ed offerta di lavoro",
	"http://elite.polito.it/disabilita`#Collocamento obbligatorio",
	"http://elite.polito.it/disabilita`#Liquidazione",
	"http://elite.polito.it/disabilita`#Chiamata pubblica",
	"http://elite.polito.it/disabilita`#Contratto Danni da lavoro",
	"http://elite.polito.it/disabilita`#Elemento di stazione-aerostazione",
	"http://elite.polito.it/disabilita`#Sala di aspetto",
	"http://elite.polito.it/disabilita`#Biglietteria",
	"http://elite.polito.it/disabilita`#Molo",
	"http://elite.polito.it/disabilita`#Sussidiarieta`",
	"http://elite.polito.it/disabilita`#Negoziazione",
	"http://elite.polito.it/disabilita`#Colloquio",
	"http://elite.polito.it/disabilita`#Colloquio di orientamento",
	"http://elite.polito.it/disabilita`#Consulenza orientativa",
	"http://elite.polito.it/disabilita`#CAAF",
	"http://elite.polito.it/disabilita`#Divieto",
	"http://elite.polito.it/disabilita`#Blocco della circolazione",
	"http://elite.polito.it/disabilita`#ZTL",
	"http://elite.polito.it/disabilita`#Multa",
	"http://elite.polito.it/disabilita`#ICF",
	"http://elite.polito.it/disabilita`#Azione di surroga",
	"http://elite.polito.it/disabilita`#Agente materiale",
	"http://elite.polito.it/disabilita`#Datore di lavoro",
	"http://elite.polito.it/disabilita`#Servizi di sostegno e di collocamento mirato",
	"http://elite.polito.it/disabilita`#Standard",
	"http://elite.polito.it/disabilita`#Tariffa",
	"http://elite.polito.it/disabilita`#Concessione speciale terza per non vedenti",
	"http://elite.polito.it/disabilita`#Concessione speciale ottava per invalidi di guerra e di servizio",
	"http://elite.polito.it/disabilita`#Carta blu",
	"http://elite.polito.it/disabilita`#Agevolazioni tariffarie",
	"http://elite.polito.it/disabilita`#Retribuzione",
	"http://elite.polito.it/disabilita`#Retribuzione pensionabile",
	"http://elite.polito.it/disabilita`#Indennita` di buonuscita",
	"http://elite.polito.it/disabilita`#Salario",
	"http://elite.polito.it/disabilita`#Stipendio",
	"http://elite.polito.it/disabilita`#Indennita` premio di fine servizio",
	"http://elite.polito.it/disabilita`#Contribuzione ai fini pensionistici",
	"http://elite.polito.it/disabilita`#Contribuzione obbligatoria",
	"http://elite.polito.it/disabilita`#Contribuzione figurativa",
	"http://elite.polito.it/disabilita`#Montante contributivo",
	"http://elite.polito.it/disabilita`#Contribuzione da riscatto",
	"http://elite.polito.it/disabilita`#Fasce deboli",
	"http://elite.polito.it/disabilita`#Persone con bisogni speciali",
	"http://elite.polito.it/disabilita`#Welfare",
	"http://elite.polito.it/disabilita`#Assicurazione obbligatoria",
	"http://elite.polito.it/disabilita`#Assicurato",
	"http://elite.polito.it/disabilita`#Addetto assicurato INAIL",
	"http://elite.polito.it/disabilita`#Condizione non professionale",
	"http://elite.polito.it/disabilita`#Ricerca di prima occupazione",
	"http://elite.polito.it/disabilita`#Patronato",
	"http://elite.polito.it/disabilita`#Categoria protetta",
	"http://elite.polito.it/disabilita`#Addestramento",
	"http://elite.polito.it/disabilita`#Capacita` lavorativa",
	"http://elite.polito.it/disabilita`#Solidarieta`",
	"http://elite.polito.it/disabilita`#Reti sociali primarie",
	"http://elite.polito.it/disabilita`#Reti formali",
	"http://elite.polito.it/disabilita`#Reti informali",
	"http://elite.polito.it/disabilita`#Reti sociali secondarie",
	"http://elite.polito.it/disabilita`#Reti",
	"http://elite.polito.it/disabilita`#Strumenti per i rapporti tra organizzazioni e cittadino",
	"http://elite.polito.it/disabilita`#Ufficio relazioni con il pubblico",
	"http://elite.polito.it/disabilita`#Carta dei servizi",
	"http://elite.polito.it/disabilita`#ADL",
	"http://elite.polito.it/disabilita`#Documento di viaggio",
	"http://elite.polito.it/disabilita`#Abbonamento",
	"http://elite.polito.it/disabilita`#Tessera",
	"http://elite.polito.it/disabilita`#Biglietto di viaggio",
	"http://elite.polito.it/disabilita`#Diritti dei lavoratori",
	"http://elite.polito.it/disabilita`#Parita` di trattamento per donne e uomini",
	"http://elite.polito.it/disabilita`#Parita` di retribuzione per lavoro di pari valore",
	"http://elite.polito.it/disabilita`#Pari opportunita` per donne e uomini",
	"http://elite.polito.it/disabilita`#Dignita` sul lavoro",
	"http://elite.polito.it/disabilita`#Parita` dei sessi",
	"http://elite.polito.it/disabilita`#Risorse strumentali e informative",
	"http://elite.polito.it/disabilita`#Back office",
	"http://elite.polito.it/disabilita`#Front office",
	"http://elite.polito.it/disabilita`#Agevolazioni per le assunzioni",
	"http://elite.polito.it/disabilita`#Mobilita` del lavoro",
	"http://elite.polito.it/disabilita`#Customer satisfaction",
	"http://elite.polito.it/disabilita`#Target",
	"http://elite.polito.it/disabilita`#Cliente-utente",
	"http://elite.polito.it/disabilita`#Utente",
	"http://elite.polito.it/disabilita`#Cliente",
	"http://elite.polito.it/disabilita`#Welfare state",
	"http://elite.polito.it/disabilita`#Welfare mix",
	"http://elite.polito.it/disabilita`#Opportunita` lavorativa",
	"http://elite.polito.it/disabilita`#Compagnia di bandiera",
	"http://elite.polito.it/disabilita`#Borsista",
	"http://elite.polito.it/disabilita`#Vita indipendente",
	"http://elite.polito.it/disabilita`#Servizi per lo impiego",
	"http://elite.polito.it/disabilita`#Private employment services",
	"http://elite.polito.it/disabilita`#Public employment services",
	"http://elite.polito.it/disabilita`#Orientamento professionale",
	"http://elite.polito.it/disabilita`#Centro per lo impiego",
	"http://elite.polito.it/disabilita`#Chiamata nominativa",
	"http://elite.polito.it/disabilita`#Organizzazione",
	"http://elite.polito.it/disabilita`#ONLUS",
	"http://elite.polito.it/disabilita`#Cooperative sociali A",
	"http://elite.polito.it/disabilita`#Cooperative sociali B",
	"http://elite.polito.it/disabilita`#Organizzazioni di volontariato",
	"http://elite.polito.it/disabilita`#Cooperative sociali",
	"http://elite.polito.it/disabilita`#CGIL",
	"http://elite.polito.it/disabilita`#UIL",
	"http://elite.polito.it/disabilita`#CISL",
	"http://elite.polito.it/disabilita`#Sindacato",
	"http://elite.polito.it/disabilita`#Organizzazioni di advocacy",
	"http://elite.polito.it/disabilita`#Fondazioni",
	"http://elite.polito.it/disabilita`#OMS",
	"http://elite.polito.it/disabilita`#Terzo settore",
	"http://elite.polito.it/disabilita`#Fornitore",
	"http://elite.polito.it/disabilita`#Opere-servizi-norme per il trasporto",
	"http://elite.polito.it/disabilita`#Check-in",
	"http://elite.polito.it/disabilita`#Aeroporto",
	"http://elite.polito.it/disabilita`#Carrello elevatore",
	"http://elite.polito.it/disabilita`#Ferrovia",
	"http://elite.polito.it/disabilita`#Stazione",
	"http://elite.polito.it/disabilita`#Autostrada",
	"http://elite.polito.it/disabilita`#Parcheggio in struttura",
	"http://elite.polito.it/disabilita`#Parcheggio a barriera",
	"http://elite.polito.it/disabilita`#Parcheggio pubblico",
	"http://elite.polito.it/disabilita`#Posto auto riservato generico",
	"http://elite.polito.it/disabilita`#Posto auto riservato personale",
	"http://elite.polito.it/disabilita`#Posto auto riservato",
	"http://elite.polito.it/disabilita`#Parcheggio",
	"http://elite.polito.it/disabilita`#Codice della strada",
	"http://elite.polito.it/disabilita`#Corsia preferenziale",
	"http://elite.polito.it/disabilita`#Area di sosta",
	"http://elite.polito.it/disabilita`#Opere aeree",
	"http://elite.polito.it/disabilita`#Opere ferroviarie",
	"http://elite.polito.it/disabilita`#Opere stradali",
	"http://elite.polito.it/disabilita`#Segmento",
	"http://elite.polito.it/disabilita`#Licenziamento",
	"http://elite.polito.it/disabilita`#Esame di guida",
	"http://elite.polito.it/disabilita`#Poverta`",
	"http://elite.polito.it/disabilita`#Bisogno",
	"http://elite.polito.it/disabilita`#Accreditamento",
	"http://elite.polito.it/disabilita`#Situazione economica e patrimoniale del lavoratore",
	"http://elite.polito.it/disabilita`#Patente speciale",
	"http://elite.polito.it/disabilita`#Foglio rosa",
	"http://elite.polito.it/disabilita`#Turnover",
	"http://elite.polito.it/disabilita`#Concessionario",
	"http://elite.polito.it/disabilita`#Azienda privata a partecipazione pubblica",
	"http://elite.polito.it/disabilita`#Azienda municipalizzata",
	"http://elite.polito.it/disabilita`#Azienda artigiana",
	"http://elite.polito.it/disabilita`#Agenzia",
	"http://elite.polito.it/disabilita`#Industria",
	"http://elite.polito.it/disabilita`#Azienda monolocalizzata",
	"http://elite.polito.it/disabilita`#Azienda plurilocalizzata",
	"http://elite.polito.it/disabilita`#Azienda non artigiana",
	"http://elite.polito.it/disabilita`#Amministrazione centrale",
	"http://elite.polito.it/disabilita`#INPS",
	"http://elite.polito.it/disabilita`#INAIL",
	"http://elite.polito.it/disabilita`#INPDAP",
	"http://elite.polito.it/disabilita`#Ente previdenziale",
	"http://elite.polito.it/disabilita`#Regione",
	"http://elite.polito.it/disabilita`#Comunita` montana",
	"http://elite.polito.it/disabilita`#Comunita` locale",
	"http://elite.polito.it/disabilita`#Provincia",
	"http://elite.polito.it/disabilita`#Comune",
	"http://elite.polito.it/disabilita`#Consorzio intercomunale dei servizi socio assistenziali",
	"http://elite.polito.it/disabilita`#Ente locale",
	"http://elite.polito.it/disabilita`#Motorizzazione civile e trasporti",
	"http://elite.polito.it/disabilita`#ACI",
	"http://elite.polito.it/disabilita`#Azienda",
	"http://elite.polito.it/disabilita`#Ente pubblico",
	"http://elite.polito.it/disabilita`#Ufficio collocamento disabili",
	"http://elite.polito.it/disabilita`#Accompagnatore",
	"http://elite.polito.it/disabilita`#Telepass",
	"http://elite.polito.it/disabilita`#Carico familiare",
	"http://elite.polito.it/disabilita`#Carrozza ferroviaria attrezzata",
	"http://elite.polito.it/disabilita`#Ricerca di lavoro",
	"http://elite.polito.it/disabilita`#Integrazione sociale",
	"http://elite.polito.it/disabilita`#Supplemento di pensione INPS",
	"http://elite.polito.it/disabilita`#Polizza di assicurazione",
	"http://elite.polito.it/disabilita`#Previdenza sociale",
	"http://elite.polito.it/disabilita`#IsDefinedBy",
	"http://elite.polito.it/disabilita`#IsPartOf",
	"http://elite.polito.it/disabilita`#Implies",
	"http://elite.polito.it/disabilita`#For",
	"http://elite.polito.it/disabilita`#Uses",
	"http://elite.polito.it/disabilita`#Manages",
	"http://elite.polito.it/disabilita`#Convenzioni per lo inserimento lavorativo" };


    private static final String uris = "http://ticino.polito.it/";
    private static final String xpath ="html/body";
    private static final String auths[] = { };
    private static final String types[] = { "default" , "simple" };

    private Random R = new Random();
    public DBWrapperImpl D;

    Spectrum testSpectrum1 = RandomSpectrum("01");
    Spectrum testSpectrum2 = RandomSpectrum("02");

    private Spectrum RandomSpectrum (String who) {

	Hashtable testVector1 = new Hashtable();

	for (int i=0; i<16+R.nextInt(16); i++) {
		double weight1 = Math.random()*2;
		testVector1.put(topics[R.nextInt(256)],new Double(weight1));
	}
	return new SpectrumImpl(uris+who+".html","html/body","mike","default",testVector1);
    }

    public DBWrapperImplTest(java.lang.String testName) {
        super(testName);
        try {
           D = new DBWrapperImpl("org.postgresql.Driver","jdbc:postgresql://ticino.polito.it/pass3/","pass3","pass3");
        }
        catch (Exception ex) {
          System.out.println(ex.toString());
        }

    }

    public static Test suite() {
        TestSuite suite = new TestSuite(DBWrapperImplTest.class);
        return suite;
    }

    /**
     * Test of insertSpectrum method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testInsertSpectrum() throws Exception {
        Integer ii = new Integer(0);
        D.setCheckann(true);
        int status;
        System.out.println("testInsertSpectrum");
	for (int i=0; i <9 ; i++) {
            status = D.insertSpectrum(RandomSpectrum("0"+Integer.toString(i)));
            if (status < 0 ){
                System.out.println ("Errore " + status +":"+ D.dbStatus());
                fail ("Errore InsertSpectrum");
            }
            else {
                System.out.println ("inserSpectrum OK");
            }
        }
    
    }

    /**
     * Test of insertXSpectrum method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testInsertXSpectrum() {

        /*
        Integer ii = new Integer(0);
              int status;
        System.out.println("testInsertXSpectrum");
       	for (int i=0; i < 9; i++) {
	 status =   D.insertXSpectrum(RandomSpectrum("0"+ii.toString(i)));
         if (status < 0 ) {
                System.out.println ("Errore " + status +":" + D.dbStatus());
                //fail ("Errore InsertXSpectrum");
            }

        }
         */
    }



    /**
     * Test of getSpectrum method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testGetSpectrum() {
        
        System.out.println("testGetSpectrum");
        Spectrum ql;
        System.out.print ("GET SPECTRUM ");
        ql = D.getSpectrum ("http://ticino.polito.it/10.html","html/body",null,null);
        if (ql != null) {
            System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
            System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getSpectrum ("http://ticino.polito.it/10.html","pippo",null,null);
        if (ql != null) {
            System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getSpectrum ("http://ticino.polito.it/10.html",null,"mike",null);
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
 }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getSpectrum ("http://ticino.polito.it/13.html","html/body","mike",null);
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getSpectrum ("http://ticino.polito.it/12.html","html/body","mike","simple");
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getSpectrum ("http://ticino.polito.it/11.html","html/body",null,"simple");
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }


        
        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
    }

    /**
     * Test of getXSpectrum method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testGetXSpectrum() {
        /*
        System.out.println("testGetXSpectrum");

        System.out.println("testGetSpectrum");
        Spectrum ql;
        System.out.print ("GET SPECTRUM ");
        ql = D.getXSpectrum ("http://ticino.polito.it/10.html","html/body",null,null);
        if (ql != null) {
            System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
            System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getXSpectrum ("http://ticino.polito.it/10.html","pippo",null,null);
        if (ql != null) {
            System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getXSpectrum ("http://ticino.polito.it/10.html",null,"mike",null);
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
 }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getXSpectrum ("http://ticino.polito.it/13.html","html/body","mike",null);
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getXSpectrum ("http://ticino.polito.it/12.html","html/body","mike","simple");
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }
        System.out.print ("GET SPECTRUM ");
        ql = D.getXSpectrum ("http://ticino.polito.it/11.html","html/body",null,"simple");
        if (ql != null) {
        System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
        System.out.println (ql.getConcepts().toString());
        }
        else {
            System.out.println(D.dbStatus());
        }

    */
        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
    }

    /**
     * Test of updateSpectrum method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testUpdateSpectrum() {
/*
      try {
        System.out.println("testUpdateSpectrum");
        Integer ii = new Integer(0);
        int status;
        System.out.println("-----");
        for (int i = 0; i < 9; i++) {
          status = D.updateSpectrum(RandomSpectrum("2" + ii.toString(i)));
          if (status < 0) {
            System.out.println("Errore " + status + ":" + D.dbStatus());
            //fail ("Errore InsertSpectrum");
          }
          else {
            System.out.println("updateSpectrum OK");
          }
        }
      }
      catch (Exception ex) {
        System.out.println(ex.toString());
      }
        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
*/
 }

    /**
     * Test of deleteSpectrum method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testDeleteSpectrum() {
     /*   System.out.println("testDeleteSpectrum");

        int q;
        System.out.print ("GET SPECTRUM ");
        q = D.deleteSpectrum ("http://ticino.polito.it/20.html","html/body",null,null);
        System.out.println("result:"+q+"//"+D.dbStatus());

        q = D.deleteSpectrum ("http://ticino.polito.it/21.html","pippo",null,null);
	System.out.println("result:"+q+"//"+D.dbStatus());
        q = D.deleteSpectrum ("http://ticino.polito.it/22.html",null,"mike",null);
	System.out.println("result:"+q+"//"+D.dbStatus());
        q = D.deleteSpectrum ("http://ticino.polito.it/23.html","html/body","mike",null);
	System.out.println("result:"+q+"//"+D.dbStatus());
        q = D.deleteSpectrum ("http://ticino.polito.it/24.html","html/body","mike","simple");
	System.out.println("result:"+q+"//"+D.dbStatus());
        q = D.deleteSpectrum ("http://ticino.polito.it/25.html","html/body",null,"simple");
	System.out.println("result:"+q+"//"+D.dbStatus());
      */
    }

    /**
     * Test of deleteXSpectrum method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testDeleteXSpectrum() {
        System.out.println("testDeleteXSpectrum");

        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
    }

    /**
     * Test of dbStatus method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testDbStatus() {
        System.out.println("testDbStatus");
        //System.out.println (D.dbStatus());
        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
    }

    /**
     * Test of searchXByTopic method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testSearchXByTopic() {
        System.out.println("testSearchXByTopic");
        /*
        Vector v = new Vector(21);
        Vector w;
        SpectrumImpl ql;

        for (int i=0; i<20; i++) {

            v.add(i,topics[i*4]);
        }

        for (int i=1; i<20; i++) {
            w = D.searchXByTopic(v,i);
            System.out.println ("LIVELLO:  "+i);
            if (w !=null) {
                for (int j=0; j<w.size();j++) {
                    System.out.println ("\tvettore j:"+j);
                    ql = (SpectrumImpl) w.get(j);
                    System.out.println (ql.getFragmentURI()+"|"+ql.getFragmentXPath()+"|"+
                            ql.getType()+"|"+ql.getAuthor());
                    System.out.println (ql.getConcepts().size());
                }
            }
            else {
                System.out.println ("W NULL:"+ D.dbStatus());
            }

        }
         */
        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
    }

    // TODO add test methods here, they have to start with 'test' name.
    // for example:
    // public void testHello() {}

    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }

    /**
     * Test of selectTopic method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testSelectTopic() {
        System.out.println("testSelectTopic");
        
        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
    }
    
    /**
     * Test of insertTopic method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testInsertTopic() {
        System.out.println("testInsertTopic");
        
        // TODO add your test code below by replacing the default call to fail.
        //fail("The test case is empty.");
    }
    
    /**
     * Test of deleteTopic method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testDeleteTopic() {
        System.out.println("testDeleteTopic");
        
        // TODO add your test code below by replacing the default call to fail.
        // fail("The test case is empty.");
    }
    
    /**
     * Test of getTopicsCoverage method, of class it.polito.elite.doseWS.wrappers.DBWrapperImpl.
     */
    public void testGetTopicsCoverage() {
        System.out.println("testGetTopicsCoverage");
        try {
            TopicCoverage I = D.getTopicsCoverage();
            System.out.println(I.toString());
        }
        catch (Exception E) {
        // TODO add your test code below by replacing the default call to fail.
        fail("OOOOpsss."+E.getMessage());
        }
    }
    
}
