/*
 * Created on Oct 19, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.wrappers;

import java.io.InputStream;
import java.net.URL;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Set;
import java.util.Iterator;

import it.polito.elite.doseWS.include.Synset;
import it.polito.elite.doseWS.include.MWord;
/**
 * @author bonino
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SynsetLoader {
	
	public static boolean loadSynset(String synsetURI, String ontologyURI, String dbDriver, String dbURI, String dbUser, String dbPassword)
	{
		//result flag
		boolean status = true;
		
		//DBaccess
		DBWrapper db = null;
		try
		{
			db = new DBWrapperImpl(dbDriver, dbURI, dbUser, dbPassword);
		}
		catch(Exception e)
		{
			//debug
			System.out.println("Error on accessing database: "+e);
		}
		//prepare the synset wrapper
		SynsetWrapper synWrapper = null;
		try
		{
			synWrapper = new SynsetWrapperImpl();
			//builds the synset URL object
			URL synURL = new URL(synsetURI);
			//gets the corresponding stream
			InputStream inStream = synURL.openStream();
			//parses the synset file
			synWrapper.parseSynset(inStream);
			//closes the stream
			inStream.close();
		}
		catch(Exception e)
		{
			//debug
			System.out.println("Error while loading the synset file: "+e);
			return false;
		}
		
		
		
		//load the ontology
		Ontology onto =new OntologyImpl(ontologyURI,true);
		
		//extracts all ontology concepts
		Vector ontoClasses = onto.getAllClasses();
		
		//extracts the classes enumeration
		Enumeration enum = ontoClasses.elements();
		
		//get all supported languages
		Set languageSet = synWrapper.getLanguages();
		
		//loads all classes
		while(enum.hasMoreElements())
		{
			//topic
			String topic = (String) enum.nextElement();
			
			//debug
			System.out.println("Topic: "+topic);
			
			//get the language iterator
			Iterator iter = languageSet.iterator();
			
			//extract synsets for all languages
			while(iter.hasNext())
			{
				//the language
				String language = (String)iter.next(); 
				try
				{
					//extract the corresponding synset
					Synset syn = synWrapper.getSynset(topic,language);
				
					//debug
					System.out.println("Synset: "+syn.toString());
					MWord mwords[] = syn.getMWords();
					for(int i=0; i<mwords.length; i++)
						System.out.println("\t"+mwords[i].getMWord());
					
					//store the synset in the db
					try
					{
						db.loadSynset(syn);
					}
					catch(Exception e)
					{
						//debug
						System.out.println("Unable to store synset: "+e);
						e.printStackTrace();
						return false;
					}
				}
				catch(NullPointerException e)
				{
					//debug
					System.out.println("[WARNING!] no synset found for <"+topic+"> language <"+language+">");
					
					//set status to fault
					status = false;
					
					//skip error and continue
					continue;
				}
			}
			
		}
		return true;
	}

}
