/*
 * Created on Oct 8, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.doseWS.wrappers;

import java.io.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.HashSet;
import java.util.Set;

import org.w3c.dom.*;
import javax.xml.parsers.*;

import it.polito.elite.doseWS.include.*;


/**
 * @author bonino
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SynsetWrapperImpl implements SynsetWrapper{

	
	private Hashtable allSyns;
	private HashSet languages;
	private Date expiration;
	
	public SynsetWrapperImpl()throws Exception 
	{
		this.allSyns = new Hashtable();
		this.languages = new HashSet();
		this.expiration = null;
	}
	
	/**
	 * @return
	 */
	public boolean parseSynset(InputStream inStream) throws Exception 
	{
		
				
		// getting the document builder Factory
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		
		// getting the document builder from the Factory
	    DocumentBuilder builder = factory.newDocumentBuilder();
		
	    // parses the xml
	    Document synDoc = builder.parse(inStream);
	    
	    // accesses the root element of the file
	    // namely the <SYNSETS> element
	    Element elemRoot = synDoc.getDocumentElement();
	    
	    try
		{
	    	// getting the expiration date value
	    	String expiration = elemRoot.getAttribute("expiration");
		
			// Expiration Date
			SimpleDateFormat df = (SimpleDateFormat) DateFormat.getDateTimeInstance();
		
			//formatting the expiration date
			df.applyPattern("yyyy:MM:dd:hh:mm:ss:S:Z");
		
			//parsing the date
			this.expiration = df.parse(expiration);
		}
	    catch(Exception e){};
  
	    //extract the Synsets elements from the synset xml file
	    NodeList synsets = elemRoot.getElementsByTagName("SYNSET");
	    
	    //for each synset element extracts the relevant information
	    //and builds a synset object
	    for(int i=0; i<synsets.getLength(); i++)
	    {
	    	
	    	//gets the element correspondent to the synset
	    	Element synset = (Element)synsets.item(i);
	    	
	    	//get the URI of the concept to which the synset is related
	    	String conceptURI = synset.getAttribute("concept");
	    	
	    	//debug
	    	//System.out.println("Concept: "+conceptURI);
	    	
	    	//gets the synset entry for a given languae
	    	NodeList synsetEntries = synset.getElementsByTagName("SYNSETENTRY");
	    	
	    	//build the synset array for this concept
	    	Hashtable conceptSyns = new Hashtable();
	    	
	    	for(int j=0; j<synsetEntries.getLength(); j++)
	    	{
	    		//gets the synsetentry element
	    		Element synsetEntry = (Element) synsetEntries.item(j);
	    		
	    		//extracts the language
	    		String language = synsetEntry.getAttribute("lang");
	    		
	    		//debug 
	    		//System.out.println("\t Lang: "+language);
	    	
	    		//gets the mwords for the current synset
		    	NodeList mwords = synsetEntry.getElementsByTagName("MWORD");
		    	
		    	//build the array for storing mwords
		    	MWord currentMWords[] = new MWord[mwords.getLength()];
		    	
		    	//for each mword extract the relevant information and build the
		    	//correspondent mword object
		    	for(int k=0; k<mwords.getLength(); k++)
		    	{
		    		//gets the element correspondent to the mword
		    		Element mword = (Element)mwords.item(k);
		    		
		    		//gets the mword
		    		String mwordEntry = ((Text)mword.getFirstChild()).getData();
		    	
		    		
		    		//gets the weight
		    		double weight = Double.parseDouble(mword.getAttribute("weight"));
		    		
		    		//debug
		    		//System.out.println("\t\t "+mwordEntry+":"+weight);
		    		
		    		//creates a new MWord object and stores it into the array
		    		currentMWords[k] = new MWord(mwordEntry,0,weight);
		    	}
		    	
		    	//loaded all mwords, building the synset object
		    	conceptSyns.put(language,new Synset(conceptURI,currentMWords,language));
		    	
		    	//loads the language if new
		    	if(!(this.languages.contains(language)))
		    		this.languages.add(language);
		    	//debug 
		    	//System.out.println(conceptSyns.toString());
	    	}
	    	
	    	//loading synsets for each concept
	    	allSyns.put(conceptURI,conceptSyns);
	    	
	    	//debug
	    	//System.out.println("Synsets: "+allSyns.toString());
	    }
	    
	    return true;
	}

	/**
	 * @param conceptURI the URI of the concept to which the required
	 *	synset belongs
	 * @param lang the language of the required synset
	 * @return
	 */
	public Synset getSynset(String conceptURI, String lang) {
		//System.out.println("getSynset"+this.allSyns.toString());
		Hashtable conceptSyns = (Hashtable) this.allSyns.get(conceptURI);
		
		//System.out.println(conceptSyns.toString());
		Synset syn = (Synset)conceptSyns.get(lang.toLowerCase());
		
		//System.out.println(syn.toString());
		return syn;
	}

	/**
	 * @return a Set of found languages
	 */
	public Set getLanguages() {
		// TODO Auto-generated method stub
		return this.languages;
	}
	
	public Date getExpiration()
	{
		return this.expiration;
	}
	
	public Enumeration getConcepts()
	{
		return this.allSyns.keys();
	}
	
	

}
